/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

L[u}bsOɂ
ˊ}bsO1
OpenGL+GLSL
*/
#include <stdio.h>
#include <stdlib.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../imageLoadSave.h"
#include <math.h>
#define M_PI 3.14159265358979

//֐̃vg^Cv錾
void init();
void idle();
void display();
void draw();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void setLight();
void setCamera();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setCubeMap();
void makeTexImage(Bitmap *bmp, int n);

//affineϊpϐ
float pos[] = { 0.0, 0.0, 0.0 };  //objectSxyzW
float scale[] = { 1.0, 1.0, 1.0 };//傫({)
float angle[] = { 0.0, 0.0, 0.0 };//]px
//l
float pos0[] = { 0.0, 0.0, 0.0 };
float scale0[] = { 1.0, 1.0, 1.0 };
float angle0[] = { 0.0, 0.0, 0.0 };
//
float lightPos[] = {10.0, 15.0, 10.0, 1.0};//ʒu
float lightPos0[] = {10.0, 15.0, 10.0, 1.0};//ʒu(l)

//JƎ̐
struct View
{
  //J
	float pos[3];//ʒui_j
	float cnt[3];//_
  float dist;  //_王_܂ł̋
  float theta; //piʂƂ̕Ίpj
  float phi;   //ʊp
  //̐
  float fovY;  //p
  float nearZ; //ONbv(ߕ)
  float farZ;  //Nbv()
};
View view = { 
	0.0, 0.0, 0.0,//pos(ݒj
  0.0, 0.0, 0.0,//cnt 
	6.0, 30.0, 0.0,//dist, theta, phi
	30.0, 1.0, 100.0//fovY,nearZ, farZ
};
View view0 = view;


//Window̃TCY
int width = 500;
int height = 500;
//AtBϊ
enum SELECT_KEY {ROTATE, SCALE, TRANSLATE, LIGHT};
SELECT_KEY sKey = TRANSLATE;
//}EX
int xStart, yStart;
bool flagMouse = false;
//wvL[tO
bool flagHelp = false;
//ʒuύXtO
bool flagLight = false;//ǉ
//ܲ԰ڰ<-->دސ؂ւtO
bool flagWireframe = false;//ǉ
//øp
#define TEX_WIDTH 64
#define TEX_HEIGHT 64
GLubyte texImage[6][TEX_HEIGHT][TEX_WIDTH][4];
GLuint texName;
GLenum target[] = {
  GL_TEXTURE_CUBE_MAP_NEGATIVE_X,//
  GL_TEXTURE_CUBE_MAP_POSITIVE_X,//E
  GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,//
  GL_TEXTURE_CUBE_MAP_POSITIVE_Y,//V
  GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,//
  GL_TEXTURE_CUBE_MAP_POSITIVE_Z,//O
};
//VF[_vO
GLuint shaderProg;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("˃}bsO1(SL_CubeReflect1");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
  init();
  initGlsl(&shaderProg, "cubeReflect1.vert", "cubeReflect1.frag");
	
  //Cxg[vɓ
  glutMainLoop();
	//\[X̉
 	glDeleteProgram(shaderProg);
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.2, 0.2, 0.3, 1.0);

  setCamera();//_߂
  setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
  printf("}EX/L[̐ɂ'h'L[vbV \n");

  //eNX`[쐬
  Bitmap* bm = new Bitmap();
  loadBitmap(bm, "../../bmp/roomNX.bmp");
  makeTexImage(bm, 0);
  loadBitmap(bm, "../../bmp/roomPX.bmp");
  makeTexImage(bm, 1);
  loadBitmap(bm, "../../bmp/roomNY.bmp");
  makeTexImage(bm, 2);
  loadBitmap(bm, "../../bmp/roomPY.bmp");
  makeTexImage(bm, 3);
  loadBitmap(bm, "../../bmp/roomNZ.bmp");
  makeTexImage(bm, 4);
  loadBitmap(bm, "../../bmp/roomPZ.bmp");
  makeTexImage(bm, 5);
  //eNX`̐ݒ
  setCubeMap();
}

void makeTexImage(Bitmap *bm, int n)
{
  int i, j, ii, jj, I, J;
  int nx = TEX_WIDTH;
  int ny = TEX_HEIGHT;
  float pWidth = (float)bm->bi.Width;
  float pHeight = (float)bm->bi.Height;

  for(j = 0; j < ny; j++)
  {
		if(n == 3) J = j;//PY(Vj
		else J = ny - 1 - j;//ʏƂ͋t
		jj = j * (int)(pHeight / (float)ny);
		for(i = 0; i < nx; i++)
		{
			if(n == 3) I = i;//PY(Vj
			else I = nx - 1 - i;//ʏƂ͋t
			ii = i * (int)(pWidth / (float)nx);
			if(bm->bi.BitCount <= 24)
			{
				texImage[n][J][I][0] = (bm->pixel[ii+jj*bm->bi.Width]).r;
				texImage[n][J][I][1] = (bm->pixel[ii+jj*bm->bi.Width]).g;
				texImage[n][J][I][2] = (bm->pixel[ii+jj*bm->bi.Width]).b;
				texImage[n][J][I][3] = (unsigned char)255;
			}
			else
			{
				texImage[n][J][I][0] = (bm->pixelA[ii+jj*bm->bi.Width]).r;
				texImage[n][J][I][1] = (bm->pixelA[ii+jj*bm->bi.Width]).g;
				texImage[n][J][I][2] = (bm->pixelA[ii+jj*bm->bi.Width]).b;
				texImage[n][J][I][3] = (bm->pixelA[ii+jj*bm->bi.Width]).a;
			}
    }
  }
	if(bm->bi.BitCount <= 24) free(bm->pixel);
	else free(bm->pixelA);
}

void setCubeMap()
{
  for(int i = 0; i < 6; i++)
	glTexImage2D(target[i],0,GL_RGBA,TEX_WIDTH,TEX_HEIGHT,0,GL_RGBA,GL_UNSIGNED_BYTE,texImage[i]);

  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_WRAP_T,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_WRAP_R,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
}

void display(void)
{
  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();//_ςƂ͂̈ʒuɕKv
  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);
  else
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, -1.0, 0.0);

	//ݒ//'l'ʒu
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  if(flagWireframe)//'w'wireframesolid model؂ւ
  {
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
  }
  else glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	//VF[_vO̗L
	glUseProgram(shaderProg);

	//_VF[_֎ϊ̓]usn
  float m[16] ;
  glGetFloatv(GL_MODELVIEW_MATRIX, m);
  GLint ViewTransLoc = glGetUniformLocation(shaderProg, "ViewTranspose");
  glUniformMatrix4fv(ViewTransLoc, 1, GL_TRUE, m);

  //fragment shaderփeNX`n
  GLint samplerLoc = glGetUniformLocation(shaderProg, "sampler");
  glUniform1i(samplerLoc, 0);//GL_TEXTURE0Kp
  //`
  draw();
  glUseProgram(0);

	if(flagHelp)
  {
		printf("L[ɂAtBϊ/ړ \n");
		printf("@,Fx \n");
		printf("@,Fy \n");
		printf("@[Shift]{,Fz \n");
		printf("@'r':] \n");
		printf("@'t':sړ \n");
		printf("@'s':ݸ \n");
		printf("@'l'Aʒüړ \n");
		printf("'w'ܲ԰ڰтƿدِ؂ւ \n");
		printf("}EXŎ_ύX \n");
		printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
		printf("  panFщEE{^NbNŒ_Eɕω \n");
		printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
		printf("  tumbleFEɃhbOƎ_Eɕω \n");
		printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
		printf("  zoomFE{^NbNŃY[C \n");
		printf("        EE{^NbNŃY[AEg \n");
		printf("[Shift]+'r'ŃZbg \n");
		flagHelp = false;
  }
  //I
  glutSwapBuffers();
}

void draw(void)
{
  float ambient[] = { 0.3, 0.3, 0.3, 1.0};
  float diffuse[] = { 0.7, 0.7, 0.7, 1.0};
  float specular[]= { 0.5, 0.5, 0.5, 1.0};

  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,100);

  glPushMatrix();
  glTranslatef(pos[0], pos[1], pos[2]);
  glRotatef(angle[2], 0.0, 0.0, 1.0);//z]
  glRotatef(angle[1], 0.0, 1.0, 0.0);//y]
  glRotatef(angle[0], 1.0, 0.0, 0.0);//x]
  glScalef(scale[0], scale[1], scale[2]);
//glutSolidCube(1.0);  //IuWFNg`
	glutSolidSphere(1.0, 20, 20);
//glutSolidTorus(0.2, 0.5, 20, 20);
//glutSolidTeapot(1.0);
  glPopMatrix();
}


void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎w
  glMatrixMode(GL_PROJECTION);
  //vWFNVs̏
  glLoadIdentity();
  //es̐ݒieϊj
  gluPerspective(view.fovY, (double)w/(double)h, view.nearZ, view.farZ);
  glMatrixMode(GL_MODELVIEW);
  //fr[s̏
  glLoadIdentity();
  //\EBhẼTCY
  width = w;
  height = h;
}

void setLight()
{
  float lightAmbient0[] = {0.5, 0.5, 0.5, 1.0}; //
  float lightDiffuse0[] = {1.0, 1.0, 1.0, 1.0}; //gU
  float lightSpecular0[] = {1.0, 1.0, 1.0, 1.0};//ʌ
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmbient0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse0);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightSpecular0);
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
}
void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'r':
	  sKey = ROTATE;
	  break;
  case 's':
	  sKey = SCALE;
	  break;
  case 't':
	  sKey = TRANSLATE;
	  break;
  case 'R'://resetilɖ߂)
		for(int i = 0; i < 3; i++)
		{
			pos[i] = pos0[i]; scale[i] = scale0[i]; angle[i] = angle0[i];
			lightPos[i] = lightPos0[i];
		}
	  view = view0;
	  setCamera();
	  break;
  case 'l':
	  sKey = LIGHT;
	  break;
  case 'w':
	  if(flagWireframe) flagWireframe = false;
	  else if(!flagWireframe) flagWireframe = true;
	  break;
  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
  if(sKey == TRANSLATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  pos[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://-x
		  pos[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) pos[1] += 0.1;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) pos[2] -= 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) pos[1] -= 0.1;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) pos[2] += 0.1; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == ROTATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x]
		  angle[0] += 10.0;
		  break;
	  case GLUT_KEY_LEFT://-x]
		  angle[0] -= 10.0;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) angle[1] += 10;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) angle[2] += 10; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) angle[1] -= 10;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) angle[2] -= 10; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == SCALE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://xg
		  scale[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://xk
		  scale[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) scale[1] += 0.1;//yg
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) scale[2] += 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) scale[1] -= 0.1;//yk
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) scale[2] -= 0.1; //z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == LIGHT)
  {
		float d = 1.0;
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  lightPos[0] += d;
		  break;
	  case GLUT_KEY_LEFT:
		  lightPos[0] -= d;//-x
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) lightPos[1] += d;//y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) lightPos[1] -= d;//-y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//-z
		  break;
	  default:
		  break;
	  }
  }
}

//ȉ̂R̊֐̓}EXɂ鎋_̕ύXɕKv
void mouse(int button, int state, int x, int y)
{
  double pp = M_PI / 180.0;

  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
  {
	  xStart = x; yStart = y;
	  flagMouse = true;
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist -= 0.5; //߂Â
	  }
  }
  else if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
  {
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist += 0.5; //
	  }
	  else if(( x < width/4 || x > 3*width/4) && (y > height/4 && y < 3*height/4))//pan
	  {
		  if(x < width/4 ) view.phi -= 1.0;
		  else view.phi += 1.0;
		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.phi) * cos(pp * view.theta);
		  view.cnt[0] = view.pos[0] - view.dist * sin(pp * view.phi) * cos(pp * view.theta);
	  }
	  else if((x > width/4 && x < 3*width/4) && (y < height/4 || y > 3*height/4))//tilt
	  {
		  if( y < height/4)
			  view.theta += 1.0; 
		  else
			  view.theta -= 1.0;

		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.theta) * cos(pp * view.phi);
		  view.cnt[0] = view.pos[0] - view.dist * cos(pp * view.theta) * sin(pp * view.phi);
		  view.cnt[1] = view.pos[1] - view.dist * sin(pp * view.theta);
	  }
	  else if(x < width/8 && y > 7*height/8) view.fovY -= 1.0;//zoom in
	  else if(x > 7*width/8 && y > 7*height/8) view.fovY += 1.0;//zoom out
  }
  else flagMouse = false;
  if(state == GLUT_DOWN) setCamera();
}

void motion(int x, int y)
{
  if(!flagMouse) return;
  if(cos(M_PI * view.theta /180.0) >= 0.0)
	view.phi -= 0.5 * (float)(x - xStart) ;//tumble
  else
	view.phi += 0.5 * (float)(x - xStart) ;//tumble

  view.theta += 0.5 * (float)(y - yStart) ;//crane

  setCamera();
  xStart = x;
  yStart = y;
}

void setCamera()
{
  double pp = M_PI / 180.0;
  view.pos[2] = view.cnt[2] + view.dist * cos(pp * view.theta) * cos(pp * view.phi);//z
  view.pos[0] = view.cnt[0] + view.dist * cos(pp * view.theta) * sin(pp * view.phi);//x
  view.pos[1] = view.cnt[1] + view.dist * sin(pp * view.theta);//y
  printf("view.posX=%f, view.posY=%f, view.posZ=%f \n", view.pos[0], view.pos[1], view.pos[2]);
  printf("cntX=%f, cntY=%f, cntZ=%f \n", view.cnt[0], view.cnt[1], view.cnt[2]);
  printf("phi=%f, theta=%f, fovY=%f \n", view.phi, view.theta, view.fovY);
	resize(width, height);
}

