/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

VhE}bsO2
OpenGL+GLSL
soft shadow
*/
#include <windows.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myPrimitive2.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void draw0();
void draw1();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void setLight();
void setCamera();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void drawFloor0(float widthX, float widthZ, int nx, int nz);
void setShadowMap();
void drawLight();
void setTextureMatrix();

//affineϊpϐ
float pos[][3] = { //ʒuisړj
	{ 0.7, 2.5, 0.0},//obj0
	{-0.7, 1.0, 0.0} //obj1
};

float pos0[][3] = {//l
	{ 0.7, 2.5, 0.0},//obj0
	{-0.7, 1.0, 0.0} //obj1
};

float scale[][3] = {//TCYiXP[Oj
	{ 1.0, 1.0, 1.0 },//obj0
	{ 1.0, 1.0, 1.0 } //obj1
};
float scale0[][3] = {//l
	{ 1.0, 1.0, 1.0 }, //obj0
	{ 1.0, 1.0, 1.0 }  //obj1
};

float angle[][3] = {//pi]j
	{ 0.0, 0.0, 0.0}, //obj0
	{ 0.0, 0.0, 0.0}  //obj1
};
float angle0[][3] = {//l
	{ 0.0, 0.0, 0.0},  //obj0
	{ 0.0, 0.0, 0.0}   //obj1
};

//
float lightPos[] =  {3.0, 6.0, 1.0, 1.0};//ʒu
float lightPos0[] = {3.0, 6.0, 1.0, 1.0};//ʒu(l)

//JƎ̐
struct View
{
  //J
	float pos[3];//ʒui_j
	float cnt[3];//_
  float dist;  //_王_܂ł̋
  float theta; //piʂƂ̕Ίpj
  float phi;   //ʊp
  //̐
  float fovY;  //p
  float nearZ; //ONbv(ߕ)
  float farZ;  //Nbv()
};
View view = { 
	0.0, 0.0, 0.0,//pos(ݒj
  0.0, 1.0, 0.0,//cnt 
	10.0, 30.0, 0.0,//dist, theta, phi
	40.0, 1.0, 100.0//fovY,nearZ, farZ
};
View view0 = view;


//Window̃TCY
int width = 500;
int height = 500;
//AtBϊ
enum SELECT_KEY {ROTATE, SCALE, TRANSLATE, LIGHT};
SELECT_KEY sKey = TRANSLATE;
//}EX
int xStart, yStart;
bool flagMouse = false;
//wvL[tO
bool flagHelp = false;
//ʒuύXtO
bool flagLight = false;
//IuWFNgʔԍ
int objNo = 0;
//]Aj[V
float ang = 0.0;
float dang = 0.1;//px
//޳ϯݸޗpø
int TEX_WIDTH = 256;
int TEX_HEIGHT = 256;
float fov = 90.0;//޳ϯݸނ̎p
float farZ = 50.0;//޳ϯݸނ̌Nbv
float dis0 = 0.05;//TvOψ
GLfloat modelview[16];  //fr[ϊs̕ۑp 
//VF[_vO
GLuint shaderProg;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("VhE}bsO2(SL_ShadowMap2)");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
  init();
  initGlsl(&shaderProg, "ShadowMap2.vert", "ShadowMap2.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteProgram(shaderProg);
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.2, 0.2, 0.3, 1.0);

  setCamera();//_߂
  setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
  glEnable(GL_CULL_FACE);
	setShadowMap();
  printf("}EX/L[̐ɂ'h'L[vbV \n");
}

void setShadowMap()
{
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);  
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  //eNX`WrpăeNZlƔr 
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE, GL_COMPARE_R_TO_TEXTURE);  
  //r̒leNZlȏȂeɂȂ 
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_FUNC, GL_LEQUAL);
	//ʂPxlƂĎ擾	
	glTexParameteri(GL_TEXTURE_2D, GL_DEPTH_TEXTURE_MODE, GL_LUMINANCE);
}

void display(void)
{
  //Ԍv
  static double time1, time2, drawTime, frame;
  if(ang <= 0.001) time1 = timeGetTime();

  //Xebv1FfvX}bv̍쐬
  glClear(GL_DEPTH_BUFFER_BIT);// fvXobt@NA
  
  // r[|[geNX`̃TCYɐݒ肷
  glViewport(0, 0, TEX_WIDTH, TEX_HEIGHT);
  
  // ϊsPʍsɐݒ肷 
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  
  //ʒu_Ƃ郂fr[ϊsݒ
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluPerspective(fov, TEX_WIDTH / TEX_HEIGHT, 1.0, farZ);
  gluLookAt(lightPos[0], lightPos[1], lightPos[2], 0.0, 0.0, 0.0, 0.0, 0.0, 1.0);

  //ݒ肵fr[sۑĂ(setTextureMatrixŎgp) 
  glGetFloatv(GL_MODELVIEW_MATRIX, modelview);

  //fvXobt@̓e擾̂
  //t[obt@ɂ͏܂Ȃ
  glColorMask(0, 0, 0, 0);
  // Itɂ 
  glDisable(GL_LIGHTING);
  //fvXobt@ɂ͔wʂ̉sL^
  glCullFace(GL_FRONT);
  //fvX}bv쐬̂߂ɃV[`
  draw0();
	draw1();
  drawFloor0(10.0, 10.0, 10, 10);
  // fvXobt@̓eeNX`ɓ] 
  glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, 0, 0, TEX_WIDTH, TEX_HEIGHT, 0);

	//XebvQ
  //ʏ̕`ݒɖ߂ 
  resize(width, height);

  glColorMask(1, 1, 1, 1); //t[obt@֏݋
  glCullFace(GL_BACK);//wʂ͕`悵Ȃ
	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();//_ςƂ͂̈ʒuɕKv
  if(cos(view.theta*M_PI/180.0) >= 0.0)// <= 90.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);
  else
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, -1.0, 0.0);

	//ݒ//'l'ʒu
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);
	glEnable(GL_LIGHTING);

 //`
  // VF[_vO̓Kp 
  glUseProgram(shaderProg);
  GLint texLoc = glGetUniformLocation(shaderProg, "shadowMap");
  glUniform1i(texLoc, 0);//GL_TEXTURE0Kp
	GLint disLoc = glGetUniformLocation(shaderProg, "dis");
	glUniform1f(disLoc, dis0);
	draw0(); 
	draw1();
  drawFloor0(10.0, 10.0, 10, 10);

  // VF[_vO̓Kp	
  glUseProgram(0);

	drawLight();//̕`

  //]pxXV
  ang += dang;
  if(ang >= 360.0)
  {
		time2 = timeGetTime();
		drawTime = (time2 - time1) * 0.001;
		frame = (360.0 / dang) / drawTime;
		printf("t[ = %4.2f[fps] \n", frame);
		//t[̕`掞
		drawTime = 1.0 / frame;
		printf("`掞 = %4.5f[spf] \n", drawTime);		
		ang = 0.0;
  }

	if(flagHelp)
  {
		printf("L[ɂAtBϊ/ړ \n");
		printf("@,Fx \n");
		printf("@,Fy \n");
		printf("@[Shift]{,Fz \n");
		printf("@'r':] \n");
		printf("@'t':sړ \n");
		printf("@'s':ݸ \n");
		printf("@'l'Aʒüړ \n");
		printf(" }EXŎ_ύX \n");
		printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
		printf("  panFщEE{^NbNŒ_Eɕω \n");
		printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
		printf("  tumbleFEɃhbOƎ_Eɕω \n");
		printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
		printf("  zoomFE{^NbNŃY[C \n");
		printf("        EE{^NbNŃY[AEg \n");
		printf("[Shift]+'r'ŃZbg \n");
		printf("[F1]L[F޳ϯݸނ̎p \n");
		printf("[F2]L[F޳ϯݸނ̌دߖʒ \n");
		printf("[F3]L[Fe̱رݸޒ \n");
		printf("[Page Up]L[F]px+0.1 \n");
		printf("[Page Dn]L[F]px-0.1 \n");
		flagHelp = false;
  }
  //I
  glutSwapBuffers();
}

void draw0(void)
{
  setTextureMatrix();
	glTranslatef(pos[0][0], pos[0][1], pos[0][2]);
  glRotatef(angle[0][2], 0.0, 0.0, 1.0);//z]
  glRotatef(angle[0][1], 0.0, 1.0, 0.0);//y]
  glRotatef(angle[0][0] + ang, 1.0, 0.0, 0.0);//x]
  glScalef(scale[0][0], scale[0][1], scale[0][2]);

	float ambient[] = { 0.0, 0.3, 0.3, 1.0};
  float diffuse[] = { 0.0, 0.7, 0.7, 1.0};
  float specular[]= { 0.5, 0.5, 0.5, 1.0};
  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,100);

	//fr[ϊsɖ߂
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
	glTranslatef(pos[0][0], pos[0][1], pos[0][2]);
  glRotatef(angle[0][2], 0.0, 0.0, 1.0);//z]
  glRotatef(angle[0][1], 0.0, 1.0, 0.0);//y]
  glRotatef(angle[0][0] + ang, 1.0, 0.0, 0.0);//x]
  glScalef(scale[0][0], scale[0][1], scale[0][2]);
  glutSolidTorus(0.2, 0.5, 20, 20);
//	glutSolidSphere(0.5, 20, 20);
  glPopMatrix();
}

void draw1(void)
{
  setTextureMatrix();
  glTranslatef(pos[1][0], pos[1][1], pos[1][2]);
  glRotatef(angle[1][2], 0.0, 0.0, 1.0);//z]
  glRotatef(angle[1][1], 0.0, 1.0, 0.0);//y]
  glRotatef(angle[1][0] + ang, 1.0, 0.0, 0.0);//x]
  glScalef(scale[1][0], scale[1][1], scale[1][2]);

  float ambient[] = { 0.3, 0.3, 0.0, 1.0};
  float diffuse[] = { 0.7, 0.7, 0.0, 1.0};
  float specular[]= { 0.5, 0.5, 0.5, 1.0};
  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,100);

	//fr[ϊsɖ߂
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
	glTranslatef(pos[1][0], pos[1][1], pos[1][2]);
  glRotatef(angle[1][2], 0.0, 0.0, 1.0);//z]
  glRotatef(angle[1][1], 0.0, 1.0, 0.0);//y]
  glRotatef(angle[1][0] + ang, 1.0, 0.0, 0.0);//x]
  glScalef(scale[1][0], scale[1][1], scale[1][2]);
//	glutSolidCube(1.0);
	drawCylinder2(1.0, 0.7, 0.5, 0.2, 20, 5);
  glPopMatrix();
}

void drawFloor0(float widthX, float widthZ, int nx, int nz)
{
  setTextureMatrix();
  int i, j;
  //FloorP̕
  float wX = widthX / (float)nx;
  float wZ = widthZ / (float)nz;

  float diffuse[][4] = {
	{ 0.7, 0.7, 0.6, 1.0}, { 0.3f, 0.4, 0.4, 1.0} };
  float ambient[] = { 0.2, 0.2, 0.2, 1.0};
  float specular[]= { 0.5, 0.5, 0.5, 1.0};
  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,100);

	//fr[ϊsɖ߂
  glMatrixMode(GL_MODELVIEW);
  glNormal3f(0.0, 1.0, 0.0);
  glPushMatrix();
  for (j = 0; j < nz; j++) 
  {
    float z1 = -widthZ / 2.0 + wZ * j; float z2 = z1 + wZ;
    for (i = 0; i < nx; i++) {
      float x1 = -widthX / 2.0 + wX * i; float x2 = x1 + wX;

      glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuse[(i + j) & 1]);
			glBegin(GL_QUADS);
      glVertex3f(x1, 0.0, z1);
      glVertex3f(x1, 0.0, z2);
      glVertex3f(x2, 0.0, z2);
      glVertex3f(x2, 0.0, z1);
			glEnd();
    }
  }
  glPopMatrix();
}

void setTextureMatrix()
{
 //eNX`ϊsݒ肷 
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  //KW [-1,1] ͈̔͂eNX`W͈̔ [0,1] ɕϊ 
  glTranslatef(0.5, 0.5, 0.5);
  glScalef(0.5, 0.5, 0.5);
	glMultMatrixf(modelview);
}
void drawLight(void)
{
	glDisable(GL_LIGHTING);
	glColor3f(1.0, 1.0, 1.0);
  glPushMatrix();
	glTranslatef(lightPos[0], lightPos[1], lightPos[2]);
	glutSolidSphere(0.02, 10, 10);
  glPopMatrix();
	glEnable(GL_LIGHTING);
}

void resize(int w, int h)
{

	//r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎w
  glMatrixMode(GL_PROJECTION);
  //vWFNVs̏
  glLoadIdentity();
  //es̐ݒieϊj
  gluPerspective(view.fovY, (double)w/(double)h, view.nearZ, view.farZ);

  //\EBhẼTCY
  width = w;
  height = h;
}

void setLight()
{
  float lightAmbient0[] = {0.5, 0.5, 0.5, 1.0}; //
  float lightDiffuse0[] = {1.0, 1.0, 1.0, 1.0}; //gU
  float lightSpecular0[] = {1.0, 1.0, 1.0, 1.0};//ʌ
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmbient0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse0);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightSpecular0);
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
}
void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'r':
	  sKey = ROTATE;
	  break;
  case 's':
	  sKey = SCALE;
	  break;
  case 't':
	  sKey = TRANSLATE;
	  break;
  case 'R'://resetilɖ߂)
		for(int j = 0; j < 2; j++)
			for(int i = 0; i < 3; i++)
			{
				pos[j][i] = pos0[j][i]; scale[j][i] = scale0[j][i]; angle[j][i] = angle0[j][i];
			}
		for(int i = 0; i < 3; i++) lightPos[i] = lightPos0[i];
	  view = view0;
	  setCamera();
	  break;
  case 'l':
	  sKey = LIGHT;
	  break;
  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
	  break;
  case '0':
	  objNo = 0;
	  break;
  case '1':
	  objNo = 1;
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
  if(sKey == TRANSLATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  pos[objNo][0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://-x
		  pos[objNo][0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) pos[objNo][1] += 0.1;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) pos[objNo][2] -= 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) pos[objNo][1] -= 0.1;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) pos[objNo][2] += 0.1; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == ROTATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x]
		  angle[objNo][0] += 10.0;
		  break;
	  case GLUT_KEY_LEFT://-x]
		  angle[objNo][0] -= 10.0;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) angle[objNo][1] += 10;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) angle[objNo][2] += 10; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) angle[objNo][1] -= 10;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) angle[objNo][2] -= 10; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == SCALE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://xg
		  scale[objNo][0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://xk
		  scale[objNo][0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) scale[objNo][1] += 0.1;//yg
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) scale[objNo][2] += 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) scale[objNo][1] -= 0.1;//yk
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) scale[objNo][2] -= 0.1; //z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == LIGHT)
  {
		float d = 0.2;
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  lightPos[0] += d;
		  break;
	  case GLUT_KEY_LEFT:
		  lightPos[0] -= d;//-x
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) lightPos[1] += d;//y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) lightPos[1] -= d;//-y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//-z
		  break;
	  default:
		  break;
	  }
  }
  if(key == GLUT_KEY_F1) 
  {
		if(glutGetModifiers() == 0) fov += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) fov -= 1.0;
	  printf("fov=%f \n",fov);
  }
  if(key == GLUT_KEY_F2) 
  {
		if(glutGetModifiers() == 0) farZ += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) farZ -= 1.0;
	  printf("farZ=%f \n",farZ);
  }
  if(key == GLUT_KEY_F3) 
  {
		if(glutGetModifiers() == 0) dis0 += 0.01;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) dis0 -= 0.01;
		if(dis0 < 0.0) dis0 = 0.0;
	  printf("dis = %f \n", dis0);
  }
	if(key == GLUT_KEY_PAGE_UP) 
	{
		dang += 0.1;
  }	
	if(key == GLUT_KEY_PAGE_DOWN) 
	{
		dang -= 0.1;
  }	
}

//ȉ̂R̊֐̓}EXɂ鎋_̕ύXɕKv
void mouse(int button, int state, int x, int y)
{
  double pp = M_PI / 180.0;

  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
  {
	  xStart = x; yStart = y;
	  flagMouse = true;
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist -= 0.5; //߂Â
	  }
  }
  else if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
  {
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist += 0.5; //
	  }
	  else if(( x < width/4 || x > 3*width/4) && (y > height/4 && y < 3*height/4))//pan
	  {
		  if(x < width/4 ) view.phi -= 1.0;
		  else view.phi += 1.0;
		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.phi) * cos(pp * view.theta);
		  view.cnt[0] = view.pos[0] - view.dist * sin(pp * view.phi) * cos(pp * view.theta);
	  }
	  else if((x > width/4 && x < 3*width/4) && (y < height/4 || y > 3*height/4))//tilt
	  {
		  if( y < height/4)
			  view.theta += 1.0; 
		  else
			  view.theta -= 1.0;

		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.theta) * cos(pp * view.phi);
		  view.cnt[0] = view.pos[0] - view.dist * cos(pp * view.theta) * sin(pp * view.phi);
		  view.cnt[1] = view.pos[1] - view.dist * sin(pp * view.theta);
	  }
	  else if(x < width/8 && y > 7*height/8) view.fovY -= 1.0;//zoom in
	  else if(x > 7*width/8 && y > 7*height/8) view.fovY += 1.0;//zoom out
  }
  else flagMouse = false;
  if(state == GLUT_DOWN) setCamera();
}

void motion(int x, int y)
{
  if(!flagMouse) return;
  if(cos(M_PI * view.theta /180.0) >= 0.0)
	view.phi -= 0.5 * (float)(x - xStart) ;//tumble
  else
	view.phi += 0.5 * (float)(x - xStart) ;//tumble

  view.theta += 0.5 * (float)(y - yStart) ;//crane

  setCamera();
  xStart = x;
  yStart = y;
}

void setCamera()
{
  double pp = M_PI / 180.0;
  view.pos[2] = view.cnt[2] + view.dist * cos(pp * view.theta) * cos(pp * view.phi);//z
  view.pos[0] = view.cnt[0] + view.dist * cos(pp * view.theta) * sin(pp * view.phi);//x
  view.pos[1] = view.cnt[1] + view.dist * sin(pp * view.theta);//y
  printf("view.posX=%f, view.posY=%f, view.posZ=%f \n", view.pos[0], view.pos[1], view.pos[2]);
  printf("cntX=%f, cntY=%f, cntZ=%f \n", view.cnt[0], view.cnt[1], view.cnt[2]);
  printf("phi=%f, theta=%f, fovY=%f \n", view.phi, view.theta, view.fovY);
	resize(width, height);
}

