/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

L[u}bsOɂ܊ϯݸ
framebuffer objectɂoff-screen rendering
OpenGL+GLSL
*/
#include <stdio.h>
#include <windows.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myPrimitive2.h"
#include "../../room2.h"
#include "../../myGlsl.h"
#include "../../imageLoadSave.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void draw();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void setLight();
void setCamera();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void setCubeMap();
void makeTexture();
void setNormalMap();
void makeNormalMap(Bitmap *bmp);
void initFramebuffer();
//ov}bsOpv~eBu
void drawBumpCube(float size, int nRepeatS, int nRepeatT);
void drawBumpSphere(double radius, int nSlice, int nStack, int nRepeatS, int nRepeatT);
void drawBumpTorus(double radius1, double radius2, int nSide, int nRing, int nRepeatS, int nRepeatT);

//affineϊpϐ
float pos[] = { 0.0, 1.5, 0.0 };  //objectSxyzW
float scale[] = { 1.0, 1.0, 1.0 };//傫({)
float angle[] = { 0.0, 0.0, 0.0 };//]px
//l
float pos0[] = { 0.0, 1.5, 0.0 };
float scale0[] = { 1.0, 1.0, 1.0 };
float angle0[] = { 0.0, 0.0, 0.0 };
//
float lightPos[] = {0.0, 5.0, 0.0, 1.0};//ʒu
float lightPos0[] = {0.0, 5.0, 0.0, 1.0};//ʒu(l)

//JƎ̐
struct View
{
  //J
	float pos[3];//ʒui_j
	float cnt[3];//_
  float dist;  //_王_܂ł̋
  float theta; //piʂƂ̕Ίpj
  float phi;   //ʊp
  //̐
  float fovY;  //p
  float nearZ; //ONbv(ߕ)
  float farZ;  //Nbv()
};
View view = { 
	0.0, 0.0, 0.0,//pos(ݒj
  0.0, 1.5, 0.0,//cnt 
	1.0, 10.0, 0.0,//dist, theta, phi
	60.0, 0.1, 10.0//fovY,nearZ, farZ
};
View view0 = view;

//Window̃TCY
int width = 500;
int height = 500;
//AtBϊ
enum SELECT_KEY {ROTATE, SCALE, TRANSLATE, LIGHT};
SELECT_KEY sKey = TRANSLATE;
//}EX
int xStart, yStart;
bool flagMouse = false;
//wvL[tO
bool flagHelp = false;
//ʒuύXtO
bool flagLight = false;//ǉ
//Aj[V
#include "../../myPet.h"
CmyPet pet ;
float curTime, lastTime, elapseTime;
int frameCount = 0;
int fps = 0;
int actionMode = 0;
float transparency0 = 0.8;//x
float nRatio0 = 2.0;//ܗ

//normal mapp
#define TEX_WIDTH 256
#define TEX_HEIGHT 256
GLubyte normalMap[TEX_HEIGHT][TEX_WIDTH][3];
float inv = 1.0;//ʔ]
float fGrad = 5.0;//z
//cube mapp
#define CUBE_WIDTH  512
#define CUBE_HEIGHT 512
//FBO֘A
GLuint	texName[2];//texture object
GLuint	rbName;//renderbuffer
GLuint	fbName;//framebuffer
//VF[_vO
GLuint shaderProg;

//eNX`[\
struct Target{
	GLenum name;//^[Qbg
	GLint x, y;//摜̈ʒu
	GLdouble cx, cy, cz;//_
	GLdouble ux, uy, uz;//AbvxNg
};

struct Target target[] = {
  { //E
    GL_TEXTURE_CUBE_MAP_POSITIVE_X,
    0, CUBE_HEIGHT,
    1.0, 0.0, 0.0,
    0.0, -1.0, 0.0,
  },
  { 
	 //
	 GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
    0, 0,
    -1.0, 0.0, 0.0,
    0.0, -1.0, 0.0,
  },
  { //V
    GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
    CUBE_WIDTH, CUBE_HEIGHT,
    0.0, 1.0, 0.0,
    0.0, 0.0, 1.0,
  },
  { 
		//
    GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
    CUBE_WIDTH,0,
    0.0, -1.0, 0.0,
    0.0, 0.0, -1.0,
  },
  { //O
    GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
    2*CUBE_WIDTH, CUBE_HEIGHT,
    0.0, 0.0, 1.0,
    0.0, -1.0, 0.0,
  },
  { //
    GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,
    2*CUBE_WIDTH, 0,
    0.0, 0.0, -1.0,
    0.0, -1.0, 0.0,
  }
};

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("ϯ(SL_RefractBump)");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
	glewInit();
  init();
	initFramebuffer();
  initGlsl(&shaderProg, "refractBump.vert", "refractBump.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteTextures(2, texName);
	glDeleteRenderbuffersEXT(1, &rbName);
	glDeleteFramebuffersEXT(1, &fbName);
	glDeleteProgram(shaderProg);
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.2, 0.2, 0.3, 1.0);

  setCamera();//_߂
  setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
  printf("}EX/L[̐ɂ'h'L[vbV \n");

  glGenTextures(2, texName);//eNX`IuWFNg̖Ot
	//cube map
  setCubeMap();//eNX`̐ݒ
  //pet robot Aj[V
  pet.unitTime = 0.05;//Pt[̎ԁiŏ͉̒lj
  //t[f[^쐬
  pet.numFrame0 = 0;
	pet.vPos.x =  1.0;
	pet.vPos.z = -1.0;
	pet.vAng.y = -90.0;
  pet.numFrame0 = 0;
  frameCount = 0;

	pet.walk(2.0, 0.2, 1.0);
	pet.turn(180.0, 2.0);
	pet.walk(2.0, 0.2, 1.0);
	pet.turn(-180.0, 2.0);
	pet.walk(2.0, 0.2, 1.0);
	pet.turn(180, 2.0);
	pet.walk(2.0, 0.2, 1.0);
	pet.turn(-180.0, 2.0);
	printf("numFrame0=%d \n", pet.numFrame0);

	makeTexture();
}

void makeTexture()
{
	//normal map
  Bitmap* bm0 = new Bitmap();
//  loadBitmap(bm0, "../../bmp256/char256-0.bmp");//disk4-256.bmp");
  loadBitmap(bm0, "../../bmp256/disk4-256.bmp");
  makeNormalMap(bm0);
  setNormalMap();
}

void makeNormalMap(Bitmap *bmp)
{//@}bvpz쐬
  int i, j, ip, jp;
  float r, g;

  if(bmp->bi.Width != TEX_WIDTH || bmp->bi.Height != TEX_HEIGHT)
  {
		printf("TEX_WIDTH,TEX_HEIGHTƃt@CTCYvĂ\n");
		return;
  }
  //BMPt@C獂}bv[h
  for(j = 0; j < TEX_HEIGHT; j++)
  {
		for(i = 0; i < TEX_WIDTH; i++)
		{
      //x}bv擾
			if(bmp->bi.BitCount <= 24)
			normalMap[j][i][2] = (bmp->pixel[i+j * TEX_WIDTH]).r;
			else//32bit color
			normalMap[j][i][2] = (bmp->pixelA[i+j * TEX_WIDTH]).r;
		}
  }
	if(bmp->bi.BitCount <= 24) free(bmp->pixel);
	else free(bmp->pixelA);

  //}bv@}bv쐬
  for(j = 0; j < TEX_HEIGHT; j++)
  {
		jp = j+1;
		if(jp >= TEX_HEIGHT) jp = 0;
		for(i = 0; i < TEX_WIDTH; i++)
		{
			ip = i+1;
			if(ip >= TEX_WIDTH) ip = 0;
			float deltaS = inv * (normalMap[j][ip][2] - normalMap[j][i][2]);
			float deltaT = inv * (normalMap[jp][i][2] - normalMap[j][i][2]);
			r = 127.5 + deltaS * fGrad;
			if(r < 0.0) r = 0.0;
			if(r > 255.0) r = 255.0;
			g = 127.5 + deltaT * fGrad;
			if(g < 0.0) g = 0.0;
			if(g > 255.0) g = 255.0;
			normalMap[j][i][0] = (GLubyte)r;
			normalMap[j][i][1] = (GLubyte)g;
			if(inv == -1.0) 
				normalMap[j][i][2] = 255 - normalMap[j][i][2];
		}
  }
}

void setNormalMap()
{
  glBindTexture(GL_TEXTURE_2D, texName[1]);//eNX`oCh
  glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,TEX_WIDTH,TEX_HEIGHT,0,GL_RGB,GL_UNSIGNED_BYTE,normalMap);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_2D, 0);//oCh
}

void initFramebuffer( void )
{
	//renderbuffer
	glGenRenderbuffersEXT( 1, &rbName );
	glBindRenderbufferEXT( GL_RENDERBUFFER_EXT, rbName );
	glRenderbufferStorageEXT( GL_RENDERBUFFER_EXT, GL_DEPTH_COMPONENT, CUBE_WIDTH, CUBE_HEIGHT );
  //framebuffer
	glGenFramebuffersEXT( 1, &fbName );
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );
	glFramebufferRenderbufferEXT( GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT,
								  GL_RENDERBUFFER_EXT, rbName );

	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setCubeMap()
{
  glBindTexture(GL_TEXTURE_CUBE_MAP, texName[0]);
  for(int i = 0; i < 6; i++)
	  glTexImage2D(target[i].name,0,GL_RGBA,CUBE_WIDTH,CUBE_HEIGHT,0,GL_RGBA,GL_UNSIGNED_BYTE, 0);

  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_WRAP_T,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_WRAP_R,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glBindTexture(GL_TEXTURE_CUBE_MAP, 0);
}


void display(void)
{
	//step1:}bv̍쐬
	//IuWFNgS猩ŨV[쐬AeNX`ɓ]
 
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );

  // ϊs̐ݒ (texture쐬j
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(90.0, 1.0, 0.1, 30.0);//p90
  
  // fr[ϊs̐ݒ 
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  // IuWFNg猩V[eNX`ɗp 
  for (int i = 0; i < 6; ++i) 
  {
    glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT,
                              target[i].name, texName[0], 0);
    glViewport(0, 0, CUBE_WIDTH, CUBE_HEIGHT);
		//J[obt@,fvXobt@̃NA
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		// IuWFNgS猩̂_O 
		glPushMatrix();
		gluLookAt(pos[0], pos[1], pos[2], 
		    pos[0]+target[i].cx, pos[1]+target[i].cy, pos[2]+target[i].cz,
				target[i].ux, target[i].uy, target[i].uz);
		glLightfv(GL_LIGHT0, GL_POSITION, lightPos);
		//3DԂ̕`
		drawRoom(10.0, 10.0, 5.0);
		glTranslatef(0.0, 1.0, 0.0);
		pet.draw(frameCount);
		glPopMatrix();
  }
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );

  //step2:ʏ̕`惋[`ɖ߂
  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  resize(width, height); 

  // VF[_vO̓Kp 
  glUseProgram(shaderProg);
  GLint tranLoc = glGetUniformLocation(shaderProg, "transparency");
  glUniform1f(tranLoc, transparency0);
  GLint ratioLoc = glGetUniformLocation(shaderProg, "nRatio");
  glUniform1f(ratioLoc, nRatio0);
  float m[16] ;
  glGetFloatv(GL_MODELVIEW_MATRIX, m);
  GLint ViewTransLoc = glGetUniformLocation(shaderProg, "ViewTranspose");
  glUniformMatrix4fv(ViewTransLoc, 1, GL_TRUE, m);

  //ݒ//'l'ʒu
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_CUBE_MAP, texName[0]);
  GLint samplerLoc = glGetUniformLocation(shaderProg, "cubeMap");
  glUniform1i(samplerLoc, 0);//GL_TEXTURE0Kp
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_2D, texName[1]);
  GLint normalLoc = glGetUniformLocation(shaderProg, "normalMap");
  glUniform1i(normalLoc, 1);//GL_TEXTURE1Kp

  //`
  draw(); 
  // VF[_vO̓Kp	
  glUseProgram(0);

  drawRoom(10.0, 10.0, 5.0);//room2.hɂ
  glTranslatef(0.0, 1.0, 0.0);
  pet.draw(frameCount);

  curTime = timeGetTime();
  //1R}̏v
  float dt = (float)(curTime - lastTime) * 0.001;//sec
  lastTime = curTime;
  elapseTime += dt;
  fps ++;
  if(elapseTime >= 1.0)
  {
  	printf("frame per sec = %d , dt = %f\n", fps, dt);
	  elapseTime = 0.0;
	  fps = 0;
  }
  frameCount++;

	if(flagHelp)
  {
		printf("L[ɂAtBϊ/ړ \n");
		printf("@,Fx \n");
		printf("@,Fy \n");
		printf("@[Shift]{,Fz \n");
		printf("@'r':] \n");
		printf("@'t':sړ \n");
		printf("@'s':ݸ \n");
		printf("@'l'Aʒüړ \n");
		printf("}EXŎ_ύX \n");
		printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
		printf("  panFщEE{^NbNŒ_Eɕω \n");
		printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
		printf("  tumbleFEɃhbOƎ_Eɕω \n");
		printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
		printf("  zoomFE{^NbNŃY[C \n");
		printf("        EE{^NbNŃY[AEg \n");
		printf("[Shift]+'r'ŃZbg \n");
		printf("[F1]L[FAj[V[hؑ \n");
		printf("[F2]L[Fߗ̑ \n");
		printf("[F3]L[Fܗ̑ \n");
		printf("[F4]L[Fʔ] \n");
		printf("[F5]L[Fz \n");
		flagHelp = false;
  }
  //I
  glutSwapBuffers();
}

void draw(void)
{
  float ambient[] = { 0.3, 0.3, 0.3, 1.0};
  float diffuse[] = { 0.7, 0.7, 0.7, 1.0};
  float specular[]= { 0.5, 0.5, 0.5, 1.0};

  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,100);

  glPushMatrix();
  glTranslatef(pos[0], pos[1], pos[2]);
  glRotatef(angle[2], 0.0, 0.0, 1.0);//z]
  glRotatef(angle[1], 0.0, 1.0, 0.0);//y]
  glRotatef(angle[0]-90.0, 1.0, 0.0, 0.0);//x]
  glScalef(scale[0], scale[1], scale[2]);
//drawBumpCube(0.4, 8, 8);  //IuWFNg`
	drawBumpSphere(0.3, 20, 20, 8, 4);
//	drawBumpTorus(0.1, 0.2, 20, 20, 16, 4);
  glPopMatrix();
}


void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎w
  glMatrixMode(GL_PROJECTION);
  //vWFNVs̏
  glLoadIdentity();
  //es̐ݒieϊj
  gluPerspective(view.fovY, (double)w/(double)h, view.nearZ, view.farZ);
  glMatrixMode(GL_MODELVIEW);
  //fr[s̏
  glLoadIdentity();

  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);
  else
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, -1.0, 0.0);
 
 //\EBhẼTCY
  width = w;
  height = h;
}

void setLight()
{
  float lightAmbient0[] = {0.5, 0.5, 0.5, 1.0}; //
  float lightDiffuse0[] = {1.0, 1.0, 1.0, 1.0}; //gU
  float lightSpecular0[] = {1.0, 1.0, 1.0, 1.0};//ʌ
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmbient0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse0);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightSpecular0);
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
}
void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'r':
	  sKey = ROTATE;
	  break;
  case 's':
	  sKey = SCALE;
	  break;
  case 't':
	  sKey = TRANSLATE;
	  break;
  case 'R'://resetilɖ߂)
		for(int i = 0; i < 3; i++)
		{
			pos[i] = pos0[i]; scale[i] = scale0[i]; angle[i] = angle0[i];
			lightPos[i] = lightPos0[i];
		}
	  view = view0;
	  setCamera();
	  break;
  case 'l':
	  sKey = LIGHT;
	  break;
  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
  if(sKey == TRANSLATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  pos[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://-x
		  pos[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) pos[1] += 0.1;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) pos[2] -= 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) pos[1] -= 0.1;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) pos[2] += 0.1; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == ROTATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x]
		  angle[0] += 10.0;
		  break;
	  case GLUT_KEY_LEFT://-x]
		  angle[0] -= 10.0;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) angle[1] += 10;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) angle[2] += 10; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) angle[1] -= 10;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) angle[2] -= 10; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == SCALE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://xg
		  scale[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://xk
		  scale[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) scale[1] += 0.1;//yg
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) scale[2] += 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) scale[1] -= 0.1;//yk
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) scale[2] -= 0.1; //z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == LIGHT)
  {
		float d = 1.0;
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  lightPos[0] += d;
		  break;
	  case GLUT_KEY_LEFT:
		  lightPos[0] -= d;//-x
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) lightPos[1] += d;//y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) lightPos[1] -= d;//-y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//-z
		  break;
	  default:
		  break;
	  }
  }
  if(key == GLUT_KEY_F1) 
  {
	actionMode += 1; 
	if(actionMode > 1) actionMode = 0;
	printf("actionMode = %d \n", actionMode);
	init();
  }	
	if(key == GLUT_KEY_F2) 
	{
	  if(glutGetModifiers() == 0) transparency0 += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	transparency0 -= 0.1;  
		if(transparency0 < 0.0) transparency0 = 0.0;
		if(transparency0 > 1.0) transparency0 = 1.0;
		printf("x= %f \n", transparency0);
	}	
	if(key == GLUT_KEY_F3) 
	{
		if(glutGetModifiers() == 0) nRatio0 += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nRatio0 -= 0.1;
		printf("ܗ= %f \n", nRatio0);		
	}
  if(key == GLUT_KEY_F4) 
  {
		inv *= -1.0;
		makeTexture();
  }	
  if(key == GLUT_KEY_F5) 
  {
		if(glutGetModifiers() == 0) fGrad += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) fGrad -= 1.0;
		if(fGrad < 0.0) fGrad = 0.0;
		printf("fGrad = %f \n", fGrad);
		makeTexture();
  }
}

//ȉ̂R̊֐̓}EXɂ鎋_̕ύXɕKv
void mouse(int button, int state, int x, int y)
{
  double pp = M_PI / 180.0;

  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
  {
	  xStart = x; yStart = y;
	  flagMouse = true;
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist -= 0.1; //߂Â
	  }
  }
  else if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
  {
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist += 0.1; //
	  }
	  else if(( x < width/4 || x > 3*width/4) && (y > height/4 && y < 3*height/4))//pan
	  {
		  if(x < width/4 ) view.phi -= 1.0;
		  else view.phi += 1.0;
		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.phi) * cos(pp * view.theta);
		  view.cnt[0] = view.pos[0] - view.dist * sin(pp * view.phi) * cos(pp * view.theta);
	  }
	  else if((x > width/4 && x < 3*width/4) && (y < height/4 || y > 3*height/4))//tilt
	  {
		  if( y < height/4)
			  view.theta += 1.0; 
		  else
			  view.theta -= 1.0;

		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.theta) * cos(pp * view.phi);
		  view.cnt[0] = view.pos[0] - view.dist * cos(pp * view.theta) * sin(pp * view.phi);
		  view.cnt[1] = view.pos[1] - view.dist * sin(pp * view.theta);
	  }
	  else if(x < width/8 && y > 7*height/8) view.fovY -= 1.0;//zoom in
	  else if(x > 7*width/8 && y > 7*height/8) view.fovY += 1.0;//zoom out
  }
  else flagMouse = false;
  if(state == GLUT_DOWN) setCamera();
}

void motion(int x, int y)
{
  if(!flagMouse) return;
  if(cos(M_PI * view.theta /180.0) >= 0.0)
	view.phi -= 0.5 * (float)(x - xStart) ;//tumble
  else
	view.phi += 0.5 * (float)(x - xStart) ;//tumble

  view.theta += 0.5 * (float)(y - yStart) ;//crane

  setCamera();
  xStart = x;
  yStart = y;
}

void setCamera()
{
  double pp = M_PI / 180.0;
  view.pos[2] = view.cnt[2] + view.dist * cos(pp * view.theta) * cos(pp * view.phi);//z
  view.pos[0] = view.cnt[0] + view.dist * cos(pp * view.theta) * sin(pp * view.phi);//x
  view.pos[1] = view.cnt[1] + view.dist * sin(pp * view.theta);//y
//  printf("view.posX=%f, view.posY=%f, view.posZ=%f \n", view.pos[0], view.pos[1], view.pos[2]);
//  printf("cntX=%f, cntY=%f, cntZ=%f \n", view.cnt[0], view.cnt[1], view.cnt[2]);
//  printf("phi=%f, theta=%f, fovY=%f \n", view.phi, view.theta, view.fovY);
	resize(width, height);
}

//------------------------------------------------------------------------------
//ϯݸޗp{
void drawBumpCube(float size, int nRepeatS, int nRepeatT)
{
	float sz, s, t, tnt[3];
	sz = 0.5 * size;
  float p[8][3] =
  { { sz, sz, sz}, {-sz, sz, sz}, {-sz,-sz, sz}, 
		{ sz,-sz, sz}, { sz, sz,-sz}, {-sz, sz,-sz},
		{-sz,-sz,-sz}, { sz,-sz,-sz}
  };

	s = (float)nRepeatS;
	t = (float)nRepeatT;

  GLuint tangentLoc = glGetAttribLocation(shaderProg, "tangent");

  glEnable(GL_TEXTURE_2D);
  glBegin(GL_QUADS);
	//top(ẑƂzj
	tnt[0] = 0.0;tnt[1] = 1.0;tnt[2] = 0.0;
	glVertexAttrib3fv(tangentLoc, tnt);
	glNormal3f(0.0f,0.0f,1.0f); 
	glTexCoord2f( s , 0.0); glVertex3fv(p[0]);
	glTexCoord2f( s ,  t ); glVertex3fv(p[1]);
	glTexCoord2f(0.0,  t ); glVertex3fv(p[2]);
	glTexCoord2f(0.0, 0.0); glVertex3fv(p[3]);
	//x(ʁj
	tnt[0] = 0.0; tnt[1] = 1.0; tnt[2] = 0.0;
	glVertexAttrib3fv(tangentLoc, tnt);
	glNormal3f(1.0f,0.0f,0.0f); 
	glTexCoord2f( s ,  t ); glVertex3fv(p[0]);
	glTexCoord2f(0.0,  t ); glVertex3fv(p[3]);
	glTexCoord2f(0.0, 0.0); glVertex3fv(p[7]);
	glTexCoord2f( s , 0.0); glVertex3fv(p[4]);
	//y
	tnt[0] = -1.0; tnt[1] = 0.0; tnt[2] = 0.0;
	glVertexAttrib3fv(tangentLoc, tnt);
	glNormal3f(0.0f,1.0f,0.0f);
	glTexCoord2f(0.0,  t ); glVertex3fv(p[0]);
	glTexCoord2f(0.0, 0.0); glVertex3fv(p[4]);
	glTexCoord2f( s , 0.0); glVertex3fv(p[5]);
	glTexCoord2f( s ,  t ); glVertex3fv(p[1]);
	//-x
	tnt[0] = 0.0; tnt[1] = 1.0; tnt[2] = 0.0;
	glVertexAttrib3fv(tangentLoc, tnt);
	glNormal3f(-1.0f,0.0f,0.0f); 
	glTexCoord2f(0.0,  t ); glVertex3fv(p[6]);
	glTexCoord2f(0.0, 0.0); glVertex3fv(p[2]);
	glTexCoord2f( s , 0.0); glVertex3fv(p[1]);
	glTexCoord2f( s ,  t ); glVertex3fv(p[5]);
	//-y
	tnt[0] = 1.0; tnt[1] = 0.0; tnt[2] = 0.0;
	glVertexAttrib3fv(tangentLoc, tnt);
	glNormal3f(0.0f,-1.0f,0.0f); 
	glTexCoord2f(0.0,  t ); glVertex3fv(p[2]);
	glTexCoord2f(0.0, 0.0); glVertex3fv(p[6]);
	glTexCoord2f( s , 0.0); glVertex3fv(p[7]);
	glTexCoord2f( s ,  t ); glVertex3fv(p[3]);
	//-z
	tnt[0] = 0.0; tnt[1] = 1.0; tnt[2] = 0.0;
	glVertexAttrib3fv(tangentLoc, tnt);
	glNormal3f(0.0f,0.0f,-1.0f); 
	glTexCoord2f(0.0, 0.0); glVertex3fv(p[6]);
	glTexCoord2f( s , 0.0); glVertex3fv(p[5]);
	glTexCoord2f( s ,  t ); glVertex3fv(p[4]);
	glTexCoord2f(0.0,  t ); glVertex3fv(p[7]);
  glEnd();
  glDisable(GL_TEXTURE_2D);
}

//̃ov}bsOp
void drawBumpSphere(double radius, int nSlice, int nStack, int nRepeatS, int nRepeatT)
{
	int i, j;
	double s, t0, t1, r0, r1, th0, th1, phi;
	double p[2][3], tnt[3];

  GLuint tangentLoc = glGetAttribLocation(shaderProg, "tangent");

	for(j = 0; j < nStack; j++)
	{
		//j=0͖kɓ_(x=0, y=0, z=radius)
		//2tW
		t0 = (double)j / (double)nStack;
		t1 = (double)(j+1) / (double)nStack;
		//̓Vp
		th0 = M_PI * t0;
		th1 = M_PI * t1;
		//x-yʂɓea
		r0 = radius * sin(th0);
		r1 = radius * sin(th1);
		//_zW
		p[0][2] = radius * cos(th0);
		p[1][2] = radius * cos(th1);
		//ڐxNĝ
		tnt[2] = 0.0;

		//ɓ_0,kɓ_1ƂtW
		t0 = (1.0 - t0) * nRepeatT;
		t1 = (1.0 - t1) * nRepeatT;

		glBegin(GL_QUAD_STRIP);
		for(i = 0; i <= nSlice; i++)
		{
			//sW
			s = (double)i / (double)nSlice;
			phi = -M_PI + 2.0 * M_PI * s;
			//_xyW(i=0^)
			p[0][0] = r0 * cos(phi);//xW
			p[0][1] = r0 * sin(phi);//yW
			p[1][0] = r1 * cos(phi);//xW
			p[1][1] = r1 * sin(phi);//yW
			//ڐxNgxy
			tnt[0] =-sin(phi);
			tnt[1] = cos(phi);

			s *= nRepeatS;

			glVertexAttrib3dv(tangentLoc, tnt);
			glTexCoord2d(s, t0);//eNX`W
			glNormal3dv(p[0]);//@xNg,KΒ_Wɓ
			glVertex3dv(p[0]);//_W

			glTexCoord2d(s, t1);//eNX`W
			glNormal3dv(p[1]);//@xNg,KΒ_Wɓ
			glVertex3dv(p[1]);//_W
		}
		glEnd();
	}
}

void drawBumpTorus(double radius1, double radius2, 
									int nSide, int nRing, int nRepeatS, int nRepeatT)
{	
	//radius1:~fʔa
	//radius2:~̒Sa
	//nSide:~fʂɂ\ʕ_
	//nRing:~Sɉ_

	int i, j;
	double rr, zz;
	double s0, s1, t, phi0, phi1, theta;
	double p[2][3], tnt[2][3];

  GLuint tangentLoc = glGetAttribLocation(shaderProg, "tangent");

	for(i = 0; i < nRing; i++)
	{
		//i=0͊{f(x=radius2𒆐SƂ~, y=0j
		//2̂W
		s0 = (double)i / (double)nRing;
		s1 = (double)(i+1) / (double)nRing;
		phi0 = 2.0 * M_PI * s0;
		phi1 = 2.0 * M_PI * s1;
		//ڐxNgxy

		tnt[0][0] = - sin(phi0);
		tnt[0][1] =   cos(phi0);
		tnt[0][2] =   0.0;
		tnt[1][0] = - sin(phi1);
		tnt[1][1] =   cos(phi1);
		tnt[1][2] =   0.0;

		//sW
		s0 *= (double)nRepeatS;
		s1 *= (double)nRepeatS;

		glEnable(GL_TEXTURE_2D);
		glBegin(GL_QUAD_STRIP);
		for(j = 0; j <= nSide; j++)
		{
			//tW
			t = (double)j / (double)nSide;
			theta = -M_PI + 2.0 * M_PI * t;
			rr = radius2 + radius1 * cos(theta);//z̋
			zz = radius1 * sin(theta);
			//_xyzW(j=0xy)
			p[0][0] = rr * cos(phi0);//xW
			p[0][1] = rr * sin(phi0);//y
			p[0][2] = zz;            //z
			p[1][0] = rr * cos(phi1);//xW
			p[1][1] = rr * sin(phi1);//y
			p[1][2] = zz;            //z  

		  t *= (double)nRepeatT;

		glVertexAttrib3dv(tangentLoc, tnt[0]);
			glTexCoord2d(s0, t);//eNX`W
			glNormal3d(cos(theta)*cos(phi0),cos(theta)*sin(phi0),sin(theta));
			glVertex3dv(p[0]);//_W

		glVertexAttrib3dv(tangentLoc, tnt[1]);
			glTexCoord2d(s1, t);//eNX`W
			glNormal3d(cos(theta)*cos(phi1),cos(theta)*sin(phi1),sin(theta));
			glVertex3dv(p[1]);//_W
		}
		glEnd();
		glDisable(GL_TEXTURE_2D);
	}
}

