/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

3DTexture
OpenGL+GLSL
*/
#include <windows.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include <math.h>
#define M_PI 3.14159265358979

//֐̃vg^Cv錾
void init();
void idle();
void display();
void draw0();
void draw1();
void drawFloor0(float widthX, float widthZ, int nx, int nz);
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void setLight();
void setCamera();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void CalcShadowMat(int objNo,float* mat);
void drawShadow();
void setTexture3D(int no);
void getImageGrain(double s0, double t0);
void getImageRandom();
void getNormalRandom();
double calcNormRandom();
void getImageSin(double lambdaX, double lambdaY, double lambdaZ);

//affineϊpϐ
float pos[][3] = { //ʒuisړj
	{ 0.7, 1.0, 0.0}, //obj0
	{-0.7, 1.0, 0.0}  //obj1
};

float pos0[][3] = {//l
	{ 0.7, 1.0, 0.0}, //obj0
	{-0.7, 1.0, 0.0}  //obj1
};

float scale[][3] = {//TCYiXP[Oj
	{ 1.0, 1.0, 1.0 },//obj0
	{ 1.0, 1.0, 1.0 } //obj1
};
float scale0[][3] = {//l
	{ 1.0, 1.0, 1.0 },//obj0
	{ 1.0, 1.0, 1.0 } //obj1
};

float angle[][3] = {//pi]j
	{ 0.0, 0.0, 0.0}, //obj0
	{ 0.0, 0.0, 0.0}  //obj1
};
float angle0[][3] = {//l
	{ 0.0, 0.0, 0.0}, //obj0
	{ 0.0, 0.0, 0.0}  //obj1
};

//
float lightPos[] = {10.0, 15.0, 10.0, 1.0};//ʒu
float lightPos0[] = {10.0, 15.0, 10.0, 1.0};//ʒu(l)
//ẽ}eA
float shadowDiffuse[] =  {0.0,0.0,0.0,0.3};//e̊gU
float shadowSpecular[] = {0.0,0.0,0.0,1.0};//e̋ʌ

//JƎ̐
struct View
{
  //J
	float pos[3];//ʒui_j
	float cnt[3];//_
  float dist;  //_王_܂ł̋
  float theta; //piʂƂ̕Ίpj
  float phi;   //ʊp
  //̐
  float fovY;  //p
  float nearZ; //ONbv(ߕ)
  float farZ;  //Nbv()
};
View view = { 
	0.0, 0.0, 0.0,//pos(ݒj
  0.0, 1.0, 0.0,//cnt 
	6.0, 30.0, 20.0,//dist, theta, phi
	30.0, 1.0, 100.0//fovY,nearZ, farZ
};
View view0 = view;

//Window̃TCY
int width = 500;
int height = 500;
//AtBϊ
enum SELECT_KEY {ROTATE, SCALE, TRANSLATE, LIGHT};
SELECT_KEY sKey = TRANSLATE;
//}EX
int xStart, yStart;
bool flagMouse = false;
//wvL[tO
bool flagHelp = false;
//ʒuύXtO
bool flagLight = false;//ǉ
//ẽtO
bool flagShadow = false;
//IuWFNgʔԍ
int objNo = 0;
//]Aj[V
float ang = 0.0;
float dang = 0.1;//px
//øp
#define TEX_WIDTH 128
#define TEX_HEIGHT 128
#define TEX_DEPTH 128
GLubyte texImage[TEX_DEPTH][TEX_HEIGHT][TEX_WIDTH][3];
GLuint texName[2];
float scaleTex = 0.5;
enum Coord { OBJECT, VIEW};
Coord coord = OBJECT;
//VF[_vO
GLuint shaderProg;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("3DeNX`(SL_3DTexture)");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
	glewInit();
  init();
  initGlsl(&shaderProg, "3DTexture.vert", "3DTexture.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteProgram(shaderProg);
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.2, 0.2, 0.3, 1.0);
 
	setCamera();//_߂
  setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
  printf("}EX/L[̐ɂ'h'L[vbV \n");
  //RDeNX`[Image炩ߍ쐬
  glGenTextures(2, texName);
  getImageGrain(0.75, 0.75);
//  getImageSin( 0.2, 0.3, 0.4);
//  getImageSin( 0.1, 0.3, 0.4);
  setTexture3D(0);
//  getImageGrain(0.5, 0.5);
//  getImageRandom();
	getNormalRandom();
  setTexture3D(1);
}

void setTexture3D(int n)
{
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  glBindTexture(GL_TEXTURE_3D, texName[n]);
  glTexImage3D(GL_TEXTURE_3D,0,GL_RGB,TEX_WIDTH,TEX_HEIGHT,TEX_DEPTH,0,GL_RGB,GL_UNSIGNED_BYTE,texImage);
  glTexParameteri(GL_TEXTURE_3D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_3D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_3D,GL_TEXTURE_WRAP_R,GL_REPEAT);

  glTexParameteri(GL_TEXTURE_3D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);//NEAREST);
  glTexParameteri(GL_TEXTURE_3D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);//NEAREST);
  glBindTexture(GL_TEXTURE_3D, 0);
}

void getImageGrain(double x0, double y0)
{ //ؖڂ̿دø
  double period ;
  double dist;
  double a1, a2;
  double x, y, z;
  double rr, gg, bb;
  int i, j, k;

  //F̐U
  a1 = 20.0;
  a2 = 30.0;

  for (k = 0; k < TEX_DEPTH; k++) 
  {
	  z = (double)k / (double)TEX_DEPTH;
		for (j = 0; j < TEX_HEIGHT; j++) 
		{
			y = (double)j / (double)TEX_HEIGHT;
			for (i = 0; i < TEX_WIDTH; i++) 
			{
				x = (double)i / (double)TEX_WIDTH;
				//Nւ̎
				period = 0.1 * (1.0 - 0.05 * z);
				//Nւ̒S̋
				dist = sqrt((x-x0) * (x-x0) + (y-y0) * (y-y0));
				//F
				rr = a1 * (sin(2.0 * M_PI * dist / period));
				gg = a2 * (sin(2.0 * M_PI * dist / period));
				bb = 50.0;
				//red
				if( rr >  - 0.7 * a1 )
					texImage[k][j][i][0] = 220 + (GLubyte)rr;
				else
					texImage[k][j][i][0] = 100 + (GLubyte)rr;

				//green
				if( gg > - 0.8 * a2)
					texImage[k][j][i][1] = 120 + (GLubyte)gg;
				else
					texImage[k][j][i][1] = 100 + (GLubyte)gg;
				//blue
				texImage[k][j][i][2] = (GLubyte)bb;
			}//i
		}//j
  }//k
}


void getImageSin(double lambdaX, double lambdaY, double lambdaZ)
{ //sin֐ɂɂدø
  double x, y, z;
  double gray;
  int i, j, k;

  for (k = 0; k < TEX_DEPTH; ++k) 
  {
		z = (double)k / (double)TEX_DEPTH;
		for (j = 0; j < TEX_HEIGHT; ++j) 
		{
			y = (double)j / (double)TEX_HEIGHT;
			for (i = 0; i < TEX_WIDTH; ++i) 
			{
				x = (double)i / (double)TEX_WIDTH;
				gray = (1.0 + sin(2.0 * M_PI * x / lambdaX )) / 3.0;
				gray += (1.0 + sin(2.0 * M_PI * y / lambdaY )) / 3.0;
				gray += (1.0 + sin(2.0 * M_PI * z / lambdaZ )) / 3.0;
				texImage[k][j][i][0] = 127 - (GLbyte)(gray * 127.0);
				texImage[k][j][i][1] = 127 - (GLbyte)(gray * 127.0);
				texImage[k][j][i][2] = 127 + (GLbyte)(gray * 127.0);
			}
		}
  }
}


void getImageRandom()
{ 
  //ɂدø
  double rr, gg, bb;
  int i, j, k;

  for (k = 0; k < TEX_DEPTH; ++k) 
  {
		for (j = 0; j < TEX_HEIGHT; ++j) 
		{
			for (i = 0; i < TEX_WIDTH; ++i) 
			{
				//F
				rr = ((double)rand() / (double)RAND_MAX - 0.5)*120.0;
				gg = ((double)rand() / (double)RAND_MAX - 0.5)*150.0;
				bb = ((double)rand() / (double)RAND_MAX - 0.5)*100.0;
				texImage[k][j][i][0] = texImage[k][j][i][1] = texImage[k][j][i][2] =150 + (GLubyte)rr;

			}
		}
  }
}

void getNormalRandom()
{
  //Kɂدø
  int i, j, k;

  for (k = 0; k < TEX_DEPTH; ++k) 
  {
		for (j = 0; j < TEX_HEIGHT; ++j) 
		{
			for (i = 0; i < TEX_WIDTH; ++i) 
			{
					//red
					texImage[k][j][i][0] = 127 + (GLubyte)(40 * calcNormRandom());
					//green
					texImage[k][j][i][1] = 127 + (GLubyte)(40 * calcNormRandom());
					//blue
					texImage[k][j][i][2] = 127 + (GLubyte)(40 * calcNormRandom());
			}
		}
  }
}

double calcNormRandom()
{
	double rr1 = (double)rand() / (double)(RAND_MAX - 0.5);
	double rr2 = (double)rand() / (double)(RAND_MAX - 0.5);
	double ran = sqrt(-2.0 * log(rr1)) * cos(2.0 * M_PI * rr2);
	return ran;
}


void display(void)
{
 //Ԍv
  static double time1, time2, drawTime, frame;
  if(ang <= 0.001) time1 = timeGetTime();

  //J[obt@,fvXobt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();//_ςƂ͂̈ʒuɕKv
  if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);
  else
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, -1.0, 0.0);

  //ݒ//'l'ʒu
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_3D, texName[0]);
  glActiveTexture(GL_TEXTURE1);
  glBindTexture(GL_TEXTURE_3D, texName[1]);
  // VF[_vO̓Kp 
  glUseProgram(shaderProg);
	GLint scaleLoc = glGetUniformLocation(shaderProg, "scale");
	glUniform1f(scaleLoc, scaleTex);
	GLint coordLoc = glGetUniformLocation(shaderProg, "coord");
	if(coord == OBJECT) glUniform1i(coordLoc, 0);
	else glUniform1i(coordLoc, 1);
  GLint texLoc = glGetUniformLocation(shaderProg, "smpl3D");
  glUniform1i(texLoc, 0);//GL_TEXTURE0Kp
  draw0(); 
  glUniform1i(texLoc, 1);//GL_TEXTURE1Kp
  draw1();
  // VF[_vO̓Kp	
  glUseProgram(0);
  drawFloor0(10.0, 10.0, 10, 10);
  //e
  drawShadow();

  //]pxXV
  ang += dang;
  if(ang >= 360.0)
  {
	time2 = timeGetTime();
	drawTime = (time2 - time1) * 0.001;//P]̕`掞
	printf("`掞 = %4.4f[s] \n", drawTime);
	frame = (360.0 / dang) / drawTime;
	printf("t[ = %4.4f[fps] \n", frame);
	ang = 0.0;
  }

  if(flagHelp)
  {
	printf("L[ɂAtBϊ/ړ \n");
	printf("@,Fx \n");
	printf("@,Fy \n");
	printf("@[Shift]{,Fz \n");
	printf("@'r':] \n");
	printf("@'t':sړ \n");
	printf("@'s':ݸ \n");
	printf("@'l'Aʒüړ \n");
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
	printf("[Shift]+'r'ŃZbg \n");
	printf("[F1]L[FeNX`̔{ \n");
	printf("[F2]L[FWn̐؂ւ \n");
	flagHelp = false;
  }
  //I
  glutSwapBuffers();
}

void draw0(void)
{
  float ambient[] = { 0.4, 0.4, 0.4, 1.0};
  float diffuse[] = { 0.8, 0.8, 0.8, 1.0};
  float specular[]= { 0.9, 0.9, 0.9, 1.0};

	if(flagShadow) 
  {
	  glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
	  glMaterialfv(GL_FRONT,GL_SPECULAR,shadowSpecular);
  }
  else
  {	
	  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
	  glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
	  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
	  glMaterialf(GL_FRONT,GL_SHININESS,100);
  }

  glPushMatrix();
	glTranslatef(pos[0][0], pos[0][1], pos[0][2]);
  glRotatef(angle[0][2], 0.0, 0.0, 1.0);//z]
  glRotatef(angle[0][1], 0.0, 1.0, 0.0);//y]
  glRotatef(angle[0][0] + ang, 1.0, 0.0, 0.0);//x]
  glScalef(scale[0][0], scale[0][1], scale[0][2]);
	glutSolidCube(0.99);
//	glutSolidSphere(0.5, 20, 20);
  glPopMatrix();
}

void draw1(void)
{
  float ambient[] = { 0.3, 0.4, 0.4, 1.0};
  float diffuse[] = { 0.6, 0.8, 0.8, 1.0};
  float specular[]= { 0.8, 0.8, 0.8, 1.0};

	if(flagShadow) 
  {
	  glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,shadowDiffuse);
	  glMaterialfv(GL_FRONT,GL_SPECULAR,shadowSpecular);
  }
  else
  {	
	  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
	  glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
	  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
	  glMaterialf(GL_FRONT,GL_SHININESS,100);
  }

  glPushMatrix();
	glTranslatef(pos[1][0], pos[1][1], pos[1][2]);
  glRotatef(angle[1][2], 0.0, 0.0, 1.0);//z]
  glRotatef(angle[1][1], 0.0, 1.0, 0.0);//y]
  glRotatef(angle[1][0] + ang, 1.0, 0.0, 0.0);//x]
  glScalef(scale[1][0], scale[1][1], scale[1][2]);
//glutSolidCube(1.0);  //IuWFNg`
//	glutSolidSphere(0.5, 20, 20);
	glutSolidTorus(0.2, 0.5, 10, 10);
  glPopMatrix();
}

void drawFloor0(float widthX, float widthZ, int nx, int nz)
{
  int i, j;
  //FloorP̕
  float wX = widthX / (float)nx;
  float wZ = widthZ / (float)nz;

  float diffuse[][4] = {
	{ 0.7, 0.7, 0.6, 1.0f}, { 0.3f, 0.4, 0.4, 1.0} };
  float ambient[] = { 0.2, 0.2, 0.2, 1.0};
  float specular[]= { 0.5, 0.5, 0.5, 1.0};

  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,10);

  glNormal3d(0.0, 1.0, 0.0);
  glPushMatrix();
  for (j = 0; j < nz; j++) {
    float z1 = -widthZ / 2.0 + wZ * j; float z2 = z1 + wZ;
    for (i = 0; i < nx; i++) {
      float x1 = -widthX / 2.0 + wX * i; float x2 = x1 + wX;

      glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuse[(i + j) & 1]);
			glBegin(GL_QUADS);
      glVertex3d(x1, 0.0, z1);
      glVertex3d(x1, 0.0, z2);
      glVertex3d(x2, 0.0, z2);
      glVertex3d(x2, 0.0, z1);
		  glEnd();
    }
  }
  glPopMatrix();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎w
  glMatrixMode(GL_PROJECTION);
  //vWFNVs̏
  glLoadIdentity();
  //es̐ݒieϊj
  gluPerspective(view.fovY, (double)w/(double)h, view.nearZ, view.farZ);
  glMatrixMode(GL_MODELVIEW);
  //fr[s̏
  glLoadIdentity();
  //\EBhẼTCY
  width = w;
  height = h;
}

void setLight()
{
  float lightAmbient0[] = {0.5, 0.5, 0.5, 1.0}; //
  float lightDiffuse0[] = {1.0, 1.0, 1.0, 1.0}; //gU
  float lightSpecular0[] = {1.0, 1.0, 1.0, 1.0};//ʌ
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmbient0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse0);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightSpecular0);
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
}
void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'r':
	  sKey = ROTATE;
	  break;
  case 's':
	  sKey = SCALE;
	  break;
  case 't':
	  sKey = TRANSLATE;
	  break;
  case 'R'://resetilɖ߂)
		for(int j = 0; j < 2; j++)
			for(int i = 0; i < 3; i++)
			{
				pos[j][i] = pos0[j][i]; scale[j][i] = scale0[j][i]; angle[j][i] = angle0[j][i];
			}
		for(int i = 0; i < 3; i++) lightPos[i] = lightPos0[i];
	  view = view0;
	  setCamera();
	  break;
  case 'l':
	  sKey = LIGHT;
	  break;
  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
	  break;
  case '0':
	  objNo = 0;
	  break;
  case '1':
	  objNo = 1;
	  break;

  default:
	  break;
  }
}

void special(int key, int x, int y)
{
  if(sKey == TRANSLATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  pos[objNo][0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://-x
		  pos[objNo][0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) pos[objNo][1] += 0.1;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) pos[objNo][2] -= 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) pos[objNo][1] -= 0.1;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) pos[objNo][2] += 0.1; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == ROTATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x]
		  angle[objNo][0] += 10.0;
		  break;
	  case GLUT_KEY_LEFT://-x]
		  angle[objNo][0] -= 10.0;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) angle[objNo][1] += 10;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) angle[objNo][2] += 10; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) angle[objNo][1] -= 10;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) angle[objNo][2] -= 10; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == SCALE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://xg
		  scale[objNo][0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://xk
		  scale[objNo][0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) scale[objNo][1] += 0.1;//yg
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) scale[objNo][2] += 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) scale[objNo][1] -= 0.1;//yk
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) scale[objNo][2] -= 0.1; //z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == LIGHT)
  {
		float d = 1.0;
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  lightPos[0] += d;
		  break;
	  case GLUT_KEY_LEFT:
		  lightPos[0] -= d;//-x
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) lightPos[1] += d;//y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) lightPos[1] -= d;//-y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//-z
		  break;
	  default:
		  break;
	  }
  }
	if(key == GLUT_KEY_F1) 
  {
	  if(glutGetModifiers() == 0) scaleTex += 0.01;
	  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) scaleTex -= 0.01;
		printf("scaleTex = %f \n", scaleTex);
	}  
	if(key == GLUT_KEY_F2)
	{
		if(coord == OBJECT) coord = VIEW;
		else coord = OBJECT;
	}

	if(key == GLUT_KEY_PAGE_UP) 
	{
		dang += 0.1;
  }	
	if(key == GLUT_KEY_PAGE_DOWN) 
	{
		dang -= 0.1;
  }	
}

//ȉ̂R̊֐̓}EXɂ鎋_̕ύXɕKv
void mouse(int button, int state, int x, int y)
{
  double pp = M_PI / 180.0;

  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
  {
	  xStart = x; yStart = y;
	  flagMouse = true;
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist -= 0.5; //߂Â
	  }
  }
  else if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
  {
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist += 0.5; //
	  }
	  else if(( x < width/4 || x > 3*width/4) && (y > height/4 && y < 3*height/4))//pan
	  {
		  if(x < width/4 ) view.phi -= 1.0;
		  else view.phi += 1.0;
		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.phi) * cos(pp * view.theta);
		  view.cnt[0] = view.pos[0] - view.dist * sin(pp * view.phi) * cos(pp * view.theta);
	  }
	  else if((x > width/4 && x < 3*width/4) && (y < height/4 || y > 3*height/4))//tilt
	  {
		  if( y < height/4)
			  view.theta += 1.0; 
		  else
			  view.theta -= 1.0;

		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.theta) * cos(pp * view.phi);
		  view.cnt[0] = view.pos[0] - view.dist * cos(pp * view.theta) * sin(pp * view.phi);
		  view.cnt[1] = view.pos[1] - view.dist * sin(pp * view.theta);
	  }
	  else if(x < width/8 && y > 7*height/8) view.fovY -= 1.0;//zoom in
	  else if(x > 7*width/8 && y > 7*height/8) view.fovY += 1.0;//zoom out
  }
  else flagMouse = false;
  if(state == GLUT_DOWN) setCamera();
}

void motion(int x, int y)
{
  if(!flagMouse) return;
  if(cos(M_PI * view.theta /180.0) >= 0.0)
	view.phi -= 0.5 * (float)(x - xStart) ;//tumble
  else
	view.phi += 0.5 * (float)(x - xStart) ;//tumble

  view.theta += 0.5 * (float)(y - yStart) ;//crane

  setCamera();
  xStart = x;
  yStart = y;
}

void setCamera()
{
  double pp = M_PI / 180.0;
  view.pos[2] = view.cnt[2] + view.dist * cos(pp * view.theta) * cos(pp * view.phi);//z
  view.pos[0] = view.cnt[0] + view.dist * cos(pp * view.theta) * sin(pp * view.phi);//x
  view.pos[1] = view.cnt[1] + view.dist * sin(pp * view.theta);//y
//  printf("view.posX=%f, view.posY=%f, view.posZ=%f \n", view.pos[0], view.pos[1], view.pos[2]);
//  printf("cntX=%f, cntY=%f, cntZ=%f \n", view.cnt[0], view.cnt[1], view.cnt[2]);
//  printf("phi=%f, theta=%f, fovY=%f \n", view.phi, view.theta, view.fovY);
	resize(width, height);
}

//2͉e`ɕKv
//------------------------------------------------------------------------
void CalcShadowMat(int ID, float* mat)
{
  float ex, ey, ez;//̕
  float a, b, c, d;//̖ʂ̃p[^
  float s; //objectS܂ł̋
  float x, y, z;

  x = lightPos[0] - pos[ID][0];
  y = lightPos[1] - pos[ID][1];
  z = lightPos[2] - pos[ID][2];

  //̕xNg
  s = sqrt(x * x + y * y + z * z);
  ex = x / s;
  ey = y / s;
  ez = z / s;

  //tA̕xNg(j
  a = 0.0;
  b = 1.0;
  c = 0.0;
  d = -0.001; //tAƉe̊h
	//shadow matrix
  mat[0] = b * ey + c * ez;
  mat[1] = -a * ey;
  mat[2] = -a * ez;
  mat[3] = 0.0;
  mat[4] = -b * ex;
  mat[5] = a * ex + c * ez;
  mat[6] = -b * ez;
  mat[7] = 0.0;
  mat[8] = -c * ex;
  mat[9] = -c * ey;
  mat[10] = a * ex + b * ey;
  mat[11] = 0.0;
  mat[12] = -d * ex;
  mat[13] = -d * ey;
  mat[14] = -d * ez;
  mat[15] = a * ex + b * ey + c * ez;
}

//-----------------------------------------------------------------------------
void drawShadow()
{
  //vZ͕sɑ΂e
  //޼ުĂƂɌ̕ςA^Iɓ_ɑ΂e
  float mat[16]; //es̗vf

  flagShadow = true;
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

	  glDepthMask(GL_FALSE);
  //e̕`
  CalcShadowMat(0, mat);
  glPushMatrix();
	  glMultMatrixf(mat);//}gNX̏Z
	  draw0();//޼ުĂ̕`
  glPopMatrix();
  CalcShadowMat(1, mat);
  glPushMatrix();
	  glMultMatrixf(mat);//}gNX̏Z
	  draw1();//޼ުĂ̕`
  glPopMatrix();

  //e̕`I
  glDepthMask(GL_TRUE);
  glDisable(GL_BLEND);
  flagShadow = false;
}


