/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

F
OpenGL+GLSLAvP[V
L[ŃAtBϊ
'r'A]
't'Asړ
's'AXP[O
,Fx
,Fy
[Shift]{,Fz
*/
#include <stdio.h>
#include <stdlib.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include <math.h>
#define M_PI 3.14159265358979

//֐̃vg^Cv錾
void init();
void idle();
void display();
void draw();
void drawColorSpace();
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void resize(int w, int h);

//affineϊpϐ
float pos[] = { 0.0, 0.0, 0.0 };//}`SxyzW
float scale[] = { 1.0, 1.0, 1.0 };//傫({)
float angle[] = { 0.0, -30.0, 0.0 };//]px
//l
float pos0[] = { 0.0, 0.0, 0.0 };//}`SxyzW
float scale0[] = { 1.0, 1.0, 1.0 };//傫({)
float angle0[] = { 0.0, -30.0, 0.0 };//]px

//JƎ̐
struct View
{
  //J
	float pos[3];//ʒui_j
	float cnt[3];//_
  float dist;//_王_܂ł̋
  float theta;//piʂƂ̕Ίpj
  float phi;//ʊp
  //̐
  float fovY;//p
  float nearZ;//ONbv
  float farZ;//Nbv
};
//l
View view = { 
	0.0, 2.0, 4.0,//pos
  0.0, 0.0, 0.0,//cnt 
	4.0, 30.0, 20.0,//dist, theta, phi
	30.0, 1.0, 100.0//fovY,nearZ, farZ
};
//Window̃TCY
int width = 500;
int height = 500;

//AtBϊ
enum SELECT_KEY {ROTATE, SCALE, TRANSLATE};
SELECT_KEY sKey = TRANSLATE;

//F̔z(jtH[ϐ̗j
float factor0 = 0.5;
float delta = 0.01;//0.0005;
//VF[_vO
GLuint shaderProg;

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("F(SL_ColorSpace2)");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
  init();
  initGlsl(&shaderProg, "ColorSpace2.vert");
 //Cxg[vɓ
  glutMainLoop();
 	glDeleteProgram(shaderProg);
 return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.2, 0.2, 0.3, 1.0);
}

void display(void)
{
  //J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT);

  if(factor0 <= 0.0) delta = 0.01;
  if(factor0 >= 1.0) delta = -0.01;
  factor0 += delta;
  //VF[_[vO̓Kp
  glUseProgram(shaderProg);
	
  GLint factorLoc = glGetUniformLocation(shaderProg, "factor");
	if(factorLoc == -1) printf("ϐԈĂ܂ \n"); 
  glUniform1f(factorLoc, factor0);
  
  draw();
  //VF[_[vO̓Kp
  glUseProgram(0);
  //I
  glutSwapBuffers();
}

void draw(void)
{
  //[h
  glPolygonMode(GL_FRONT, GL_FILL);
  glPolygonMode(GL_BACK, GL_POINT);
  glPushMatrix();
  glTranslatef(pos[0], pos[1], pos[2]);
  glRotatef(angle[2], 0.0, 0.0, 1.0);//z]
  glRotatef(angle[1], 0.0, 1.0, 0.0);//y]
  glRotatef(angle[0], 1.0, 0.0, 0.0);//x]
  glScalef(scale[0], scale[1], scale[2]);

  drawColorSpace();//IuWFNg`
  glPopMatrix();
}

void drawColorSpace()
{
	float p[8][3] = 
	{ {0.5, 0.5, 0.5}, {-0.5, 0.5, 0.5}, {-0.5, -0.5, 0.5}, {0.5, -0.5, 0.5},
	  {0.5, 0.5, -0.5}, {-0.5, 0.5, -0.5}, {-0.5, -0.5, -0.5}, {0.5, -0.5, -0.5}
	};
	float c[8][3] = //e_̐F
	{ {1.0, 1.0, 1.0}, {1.0, 0.0, 1.0}, {1.0, 0.0, 0.0}, {1.0,1.0, 0.0},
	  {0.0, 1.0, 1.0}, {0.0, 0.0, 1.0}, {0.0, 0.0, 0.0}, {0.0, 1.0, 0.0}
	};
	
	glBegin(GL_QUADS);
		glNormal3f(0.0f,0.0f,1.0f); //z
		glColor3fv(c[0]); glVertex3fv(p[0]); 
		glColor3fv(c[1]); glVertex3fv(p[1]);
		glColor3fv(c[2]); glVertex3fv(p[2]); 
		glColor3fv(c[3]); glVertex3fv(p[3]);

		glNormal3f(1.0f,0.0f,0.0f); //x
		glColor3fv(c[0]); glVertex3fv(p[0]);
		glColor3fv(c[3]); glVertex3fv(p[3]);
		glColor3fv(c[7]); glVertex3fv(p[7]);
		glColor3fv(c[4]); glVertex3fv(p[4]);

		glNormal3f(0.0f,1.0f,0.0f); //y
		glColor3fv(c[0]); glVertex3fv(p[0]); 
		glColor3fv(c[4]); glVertex3fv(p[4]);
		glColor3fv(c[5]); glVertex3fv(p[5]); 
		glColor3fv(c[1]); glVertex3fv(p[1]);

	 	glNormal3f(-1.0f,0.0f,0.0f); //-x
		glColor3fv(c[1]); glVertex3fv(p[1]); 
		glColor3fv(c[5]); glVertex3fv(p[5]);
		glColor3fv(c[6]); glVertex3fv(p[6]); 
		glColor3fv(c[2]); glVertex3fv(p[2]);

		glNormal3f(0.0f,-1.0f,0.0f); //-y
		glColor3fv(c[2]); glVertex3fv(p[2]); 
		glColor3fv(c[6]); glVertex3fv(p[6]);
		glColor3fv(c[7]); glVertex3fv(p[7]); 
		glColor3fv(c[3]); glVertex3fv(p[3]);

		glNormal3f(0.0f,0.0f,-1.0f); //-z
		glColor3fv(c[4]); glVertex3fv(p[4]); 
		glColor3fv(c[7]); glVertex3fv(p[7]);
		glColor3fv(c[6]); glVertex3fv(p[6]); 
		glColor3fv(c[5]); glVertex3fv(p[5]);
	glEnd();
}

void resize(int w, int h)
{
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(view.fovY, (double)w/(double)h, view.nearZ, view.farZ);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);	
  width = w;
  height = h;
}

void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'r':
	  sKey = ROTATE;
	  break;
  case 's':
	  sKey = SCALE;
	  break;
  case 't':
	  sKey = TRANSLATE;
	  break;
  case 'R'://resetilɖ߂)
	  for(int i = 0; i < 3; i++)
		{
			pos[i] = pos0[i];
			scale[i] = scale0[i];
			angle[i] = angle0[i];
		}
	  break;
  default:
	  break;
  }
}

void special(int key, int x, int y)
{
  if(sKey == TRANSLATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  pos[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://-x
		  pos[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) pos[1] += 0.1;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) pos[2] -= 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) pos[1] -= 0.1;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) pos[2] += 0.1; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == ROTATE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x]
		  angle[0] += 10.0;
		  break;
	  case GLUT_KEY_LEFT://-x]
		  angle[0] -= 10.0;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) angle[1] += 10;//y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) angle[2] += 10; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) angle[1] -= 10;//-y
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) angle[2] -= 10; //-z
		  break;
	  default:
		  break;
	  }
  }
  else if(sKey == SCALE)
  {
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://xg
		  scale[0] += 0.1;
		  break;
	  case GLUT_KEY_LEFT://xk
		  scale[0] -= 0.1;
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) scale[1] += 0.1;//yg
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) scale[2] += 0.1; //z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) scale[1] -= 0.1;//yk
		  else if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) scale[2] -= 0.1; //z
		  break;
	  default:
		  break;
	  }
  }
}
