/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

W͗l2
OpenGL+GLSL
*/
#include <windows.h>
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include "../../myGlsl.h"
#include "../../myPrimitive2.h"
#include "wave.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void resize(int w, int h);
void keyboard(unsigned char key, int x, int y);
void special(int key, int x, int y);
void setLight();
void setCamera();
void mouse(int button, int state, int x, int y);
void motion(int x, int y);
void CalcShadowMat(int objNo,float* mat);
void drawShadow();
void makeTexImage();
void setTextureCaustics();
void setCubeMap();
void drawFloor0(float widthX, float widthZ, int nx, int nz);
void setTextureMatrix();
void drawLight();
void initFramebuffer();

//
float lightPos[] = {0.0, 10.0, 0.0, 1.0};//ʒu
float lightPos0[] = {0.0, 10.0, 0.0, 1.0};//ʒu(l)
//eS
float projCenter[] = {0.0, 10.0, 0.0, 1.0};
//ẽ}eA
float shadowDiffuse[] =  {0.0,0.0,0.0,0.1};//e̊gU
float shadowSpecular[] = {0.0,0.0,0.0,1.0};//e̋ʌ

//JƎ̐
struct View
{
  //J
	float pos[3];//ʒui_j
	float cnt[3];//_
  float dist;  //_王_܂ł̋
  float theta; //piʂƂ̕Ίpj
  float phi;   //ʊp
  //̐
  float fovY;  //p
  float nearZ; //ONbv(ߕ)
  float farZ;  //Nbv()
};
View view = { 
	0.0, 0.0, 0.0,//pos(ݒj
  0.0, 2.0, 0.0,//cnt 
	6.0, 50.0, 0.0,//dist, theta, phi
	100.0, 1.0, 100.0//fovY,nearZ, farZ
};
View view0 = view;

//Window̃TCY
int width = 500;
int height = 500;
//AtBϊ
enum SELECT_KEY {LIGHT};
SELECT_KEY sKey = LIGHT;
//}EX
int xStart, yStart;
bool flagMouse = false;
//ܲ԰ڰ<-->دސ؂ւtO
bool flagWireframe = false;
//wvL[tO
bool flagHelp = false;
//ʒuύXtO
bool flagLight = false;//ǉ
//ẽtO
bool flagShadow = false;
//xƔܗ
float transparency0 = 0.8;
float nRatio0 = 1.02;

//ø摜(W͗lpj
#define TEX_WIDTH 128
#define TEX_HEIGHT 128
GLubyte texImage[TEX_HEIGHT][TEX_WIDTH][3];
//CubeMapp
#define TEX_WIDTH2  512
#define TEX_HEIGHT2 512
//VF[_vO
GLuint shaderProg1, shaderProg2;
//FBO֘A
GLuint texName[2];
GLuint	rbName;//renderbuffer
GLuint	fbName;//framebuffer

//oߎ
double curTime, lastTime, elapseTime1, elapseTime2;
int fps = 0;//frame per sec
float amp = 1.0;//g̐U

//Aj[V
#include "slFish1.h"
CFish1 fish1 ;
#include "slFish2.h"
CFish2 fish2 ;
GLfloat fov = 60.0;//e}bsO̎p

//eNX`[\(cube map)
struct Target{
	GLenum name;//^[Qbg
	GLint x, y;//摜̈ʒu
	GLdouble cx, cy, cz;//_
	GLdouble ux, uy, uz;//AbvxNg
};

struct Target target[] = {
  { //E
    GL_TEXTURE_CUBE_MAP_POSITIVE_X,
    0, TEX_HEIGHT2,
    1.0, 0.0, 0.0,
    0.0, -1.0, 0.0,
  },
  { 
	 //
	 GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
    0, 0,
    -1.0, 0.0, 0.0,
    0.0, -1.0, 0.0,
  },
  { //V
    GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
    TEX_WIDTH2, TEX_HEIGHT2,
    0.0, 1.0, 0.0,
    0.0, 0.0, 1.0,
  },
  { 
		//
    GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
    TEX_WIDTH2, 0,
    0.0, -1.0, 0.0,
    0.0, 0.0, -1.0,
  },
  { //O
    GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
    2*TEX_WIDTH2, TEX_HEIGHT2,
    0.0, 0.0, 1.0,
    0.0, -1.0, 0.0,
  },
  { //
    GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,
    2*TEX_WIDTH2, 0,
    0.0, 0.0, -1.0,
    0.0, -1.0, 0.0,
  }
};

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  //\[h
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  //\EBhẼTCY
  glutInitWindowSize(width, height);
  //̈ʒu
  glutInitWindowPosition(100, 100);
  //EBhE쐬
  glutCreateWindow("W͗l2(SL_Caustics2)");
  //EBhẼTCYύX
  glutReshapeFunc(resize);
  //\
  glutDisplayFunc(display);
  //L[{[h̗p
  glutKeyboardFunc(keyboard);
  //L[Ȃǂ̓L[p
  glutSpecialFunc(special);
  //}EX
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  //ĕ`
  glutIdleFunc(idle);
  //ݒ
	glewInit();
  init();
	initFramebuffer();
  initGlsl(&shaderProg1, "projection.vert", "projection.frag");
  initGlsl(&shaderProg2, "refraction.vert", "refraction.frag");
  //Cxg[vɓ
  glutMainLoop();
	glDeleteTextures(2, texName);
	glDeleteRenderbuffersEXT(1, &rbName);
	glDeleteFramebuffersEXT(1, &fbName);
	glDeleteProgram(shaderProg1);
	glDeleteProgram(shaderProg2);
  return 0;
}

void idle(void)
{
  //ĕ`
  glutPostRedisplay();
}

void init(void)
{
 //wiF
  glClearColor(0.2, 0.2, 0.3, 1.0);

  setCamera();//_߂
  setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
  glEnable(GL_NORMALIZE);
  printf("}EX/L[̐ɂ'h'L[vbV \n");

	//Ԋ֌W
  lastTime = timeGetTime();
  fps = 0;
  elapseTime1 = 0.0;//1secԈȓ̌oߎ
  elapseTime2 = 0.0; //init()̑oߎ

  glGenTextures(2, texName);

	makeWavePlane(amp, elapseTime2);
	makeTexImage();
	setTextureCaustics();
  //CubeMap̐ݒ
  setCubeMap();
}

void makeTexImage()
{
  int i, j;
	float v, a;

  for(j = 0; j < TEX_HEIGHT; j++)
		for(i = 0; i < TEX_WIDTH; i++)
    {
			v = data[j * (nMesh + 1) + i];
			if(kindWave == 0) a = 180.0 + 75.0 * v;
			else              a = 250.0 - 100.0 * v*v ;
			if(a >= 255.0) a = 255.0;
			if(a < 120) a = 120;
 			texImage[j][i][0] = texImage[j][i][1] = texImage[j][i][2] = (GLubyte)a;
    }
}

void setTextureCaustics()
{//W͗lp
  glBindTexture(GL_TEXTURE_2D, texName[0]);//geNX`oCh
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,TEX_WIDTH,TEX_HEIGHT,0,GL_RGB,GL_UNSIGNED_BYTE,texImage);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

	glBindTexture(GL_TEXTURE_2D, 0);//oCh
}

void initFramebuffer()
{
	//renderbuffer
	glGenRenderbuffersEXT( 1, &rbName );
	glBindRenderbufferEXT( GL_RENDERBUFFER_EXT, rbName );
	glRenderbufferStorageEXT( GL_RENDERBUFFER_EXT, GL_DEPTH_COMPONENT, TEX_WIDTH2, TEX_HEIGHT2 );
  //framebuffer
	glGenFramebuffersEXT( 1, &fbName );
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );
	glFramebufferRenderbufferEXT( GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT,
								  GL_RENDERBUFFER_EXT, rbName );

	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setCubeMap()
{//L[u}bvp
  glBindTexture(GL_TEXTURE_CUBE_MAP, texName[1]);//}bvoCh
  for(int i = 0; i < 6; i++)
	glTexImage2D(target[i].name,0,GL_RGBA,TEX_WIDTH2,TEX_HEIGHT2,0,GL_RGBA,GL_UNSIGNED_BYTE,0);

  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_WRAP_T,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_WRAP_R,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_MAG_FILTER,GL_LINEAR);//NEAREST);
  glTexParameteri(GL_TEXTURE_CUBE_MAP,GL_TEXTURE_MIN_FILTER,GL_LINEAR);//NEAREST);
  glBindTexture(GL_TEXTURE_CUBE_MAP, 0);//oCh
}


void display(void)
{
 	//Ԍv
  curTime = timeGetTime();
  float dt = (float)(curTime - lastTime) * 0.001;//secɕϊ
  elapseTime1 += dt;
  elapseTime2 += dt;
  fps ++;
  if(elapseTime1 >= 1.0)
  {
		printf("frame per sec = %d \n", fps);
		elapseTime1 = 0.0;
		fps = 0;
  }
  lastTime = curTime;

	//STEP1:gf[^яW͗l̍쐬
	if(kindWave == 0) makeWaveCircle(amp, elapseTime2);
	else if(kindWave == 1) makeWavePlane(amp, elapseTime2);
	else makeWaveMix(amp, elapseTime2);
	makeTexImage();
	setTextureCaustics();

	//STEP2:܃}bsOp̃eNX`摜̍쐬

	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbName );

  // ϊs̐ݒ (texture쐬j
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(90.0, 1.0, 0.1, 20.0);//p90
  // fr[ϊs̐ݒ 
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_2D, texName[0]);
  //fragment shader̃jtH[ϐsmplCaustics̃CfbNX擾
  GLint texLoc1 = glGetUniformLocation(shaderProg1, "smplCaustics");
  glUniform1i(texLoc1, 0);//GL_TEXTURE0Kp

  //gS猩V[܃}bsOɗp 
  for (int i = 0; i < 6; ++i) 
  {
    glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT,
                              target[i].name, texName[1], 0);
    glViewport(0, 0, TEX_WIDTH2, TEX_HEIGHT2);
		//J[obt@,fvXobt@̃NA
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glPushMatrix();
		// gS猩̂_O 
		gluLookAt(0.0, waveH, 0.0, target[i].cx, waveH+target[i].cy, target[i].cz,
				target[i].ux, target[i].uy, target[i].uz);

		//W͗lpVF[_vO̓Kp  
		glUseProgram(shaderProg1);
		//Caustics̑Ώۂ_O
		fish1.motion1(elapseTime2);
		fish2.motion1(elapseTime2);
		drawFloor0(10.0, 10.0, 10, 10);
		glUseProgram(0);
 		glPopMatrix();
  }
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );

	//STEP3:ۂ̃IuWFNgɏW͗lp_O 
	resize(width, height);
	//J[obt@̃NA
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  if(cos(M_PI * view.theta /180.0) > 0.0)//Jp90xޭ޸ِؑ
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, 1.0, 0.0);
  else
	  gluLookAt(view.pos[0], view.pos[1], view.pos[2], view.cnt[0], view.cnt[1], view.cnt[2], 0.0, -1.0, 0.0);

  //ݒ//'l'ʒu
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

  glUseProgram(shaderProg1);// VF[_vO̓Kp
	fish1.motion1(elapseTime2);
	fish2.motion1(elapseTime2);
	drawFloor0(10.0, 10.0, 10, 10);
  glUseProgram(0);//VF[_vO̓Kp

  //STEP4:ϯݸޗpVF[_vO̓Kp 
	//eNX`jbg0texName[1]Ɋ蓖Ă
  glActiveTexture(GL_TEXTURE0);
  glBindTexture(GL_TEXTURE_CUBE_MAP, texName[1]);
  GLint texLoc2 = glGetUniformLocation(shaderProg2, "smplRefract");
  glUniform1i(texLoc2, 0);//GL_TEXTURE0Kp
  glUseProgram(shaderProg2);
  GLint tranLoc = glGetUniformLocation(shaderProg2, "transparency");
  glUniform1f(tranLoc, transparency0);
  GLint ratioLoc = glGetUniformLocation(shaderProg2, "nRatio");
  glUniform1f(ratioLoc, nRatio0);
  GLint inverseLoc = glGetUniformLocation(shaderProg2, "flagInverse");
	int flagInverse = -1;
	if(view.pos[1] < waveH) flagInverse = 1;//_ʈȉ
  glUniform1i(inverseLoc, flagInverse);
  float m[16] ;
  glGetFloatv(GL_MODELVIEW_MATRIX, m);
  GLint ViewTransLoc = glGetUniformLocation(shaderProg2, "ViewTranspose");
  glUniformMatrix4fv(ViewTransLoc, 1, GL_TRUE, m);//GL_TRUEœ]us
	
	drawWave();//܊}bsȎΏ
	glUseProgram(0);

  //e
  drawShadow();

	drawLight();

  if(flagHelp)
  {
		printf("L[ɂ/eSړ \n");
		printf("@,Fx \n");
		printf("@,Fy \n");
		printf("@[Shift]{,Fz \n");
		printf("@'l'Aʒüړ \n");
		printf("}EXŎ_ύX \n");
		printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
		printf("  panFщEE{^NbNŒ_Eɕω \n");
		printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
		printf("  tumbleFEɃhbOƎ_Eɕω \n");
		printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
		printf("  zoomFE{^NbNŃY[C \n");
		printf("        EE{^NbNŃY[AEg \n");
		printf("[Shift]+'r'ŃZbg \n");
		printf("[F1]L[Fe}bsO̎pfov̑ \n");
		printf("[F2]L[Fg̐Uamp \n");
		printf("[F3]L[Fg̎ށi~`gƕʔgj̐؂ւ \n");
		printf("[F4]L[F~`ǧ؂ւ \n");
		printf("[F5]L[Fߗ̑ \n");
		printf("[F6]L[Fܗ̑ \n");
		flagHelp = false;
  }
  //I
  glutSwapBuffers();
}

void setTextureMatrix()
{
 //eNX`ϊsݒ肷 
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();

  //KW [-1,1] ͈̔͂eNX`W͈̔ [0,1] ɕϊ 
  glTranslatef(0.5, 0.5, 0.5);
  glScalef(0.5, 0.5, 0.5);
  gluPerspective(fov, 1.0, 0.1, 50.0);
	gluLookAt(lightPos[0], lightPos[1], lightPos[2], 0.0, waveH, 0.0, 0.0, 0.0, -1.0);
//	gluLookAt(projCenter[0], projCenter[1], projCenter[2], 0.0, waveH, 0.0, 0.0, 0.0, -1.0);

}

void drawFloor0(float widthX, float widthZ, int nx, int nz)
{
  int i, j;
  //FloorP̕
  float wX = widthX / (float)nx;
  float wZ = widthZ / (float)nz;

  float diffuse[][4] = {
	{ 0.7, 0.7, 0.6, 1.0}, { 0.3f, 0.4, 0.4, 1.0} };
  float ambient[] = { 0.2, 0.2, 0.2, 1.0};
  float specular[]= { 0.5, 0.5, 0.5, 1.0};
  glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
  glMaterialf(GL_FRONT,GL_SHININESS,100);

  setTextureMatrix();
  //ʏ̃fr[ϊɖ߂ 
  glMatrixMode(GL_MODELVIEW);
  glNormal3f(0.0, 1.0, 0.0);
  glPushMatrix();
  for (j = 0; j < nz; j++) 
  {
    float z1 = -widthZ / 2.0 + wZ * j; float z2 = z1 + wZ;
    for (i = 0; i < nx; i++) {
      float x1 = -widthX / 2.0 + wX * i; float x2 = x1 + wX;

      glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuse[(i + j) & 1]);
			glBegin(GL_QUADS);
      glVertex3f(x1, 0.0, z1);
      glVertex3f(x1, 0.0, z2);
      glVertex3f(x2, 0.0, z2);
      glVertex3f(x2, 0.0, z1);
			glEnd();
    }
  }
  glPopMatrix();
}

void resize(int w, int h)
{
  //r[|[gϊ
  glViewport(0, 0, w, h);
  //vWFNVs̎w
  glMatrixMode(GL_PROJECTION);
  //vWFNVs̏
  glLoadIdentity();
  //es̐ݒieϊj
  gluPerspective(view.fovY, (double)w/(double)h, view.nearZ, view.farZ);
  glMatrixMode(GL_MODELVIEW);
  //fr[s̏
  glLoadIdentity();
  //\EBhẼTCY
  width = w;
  height = h;
}

void drawLight(void)
{
	glDisable(GL_LIGHTING);
	glColor3f(1.0, 1.0, 1.0);
  glPushMatrix();
	glTranslatef(lightPos[0], lightPos[1], lightPos[2]);
	glutSolidSphere(0.03, 10, 10);
  glPopMatrix();
	glEnable(GL_LIGHTING);
}

void setLight()
{
  float lightAmbient0[] = {0.5, 0.5, 0.5, 1.0}; //
  float lightDiffuse0[] = {1.0, 1.0, 1.0, 1.0}; //gU
  float lightSpecular0[] = {1.0, 1.0, 1.0, 1.0};//ʌ
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightAmbient0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightDiffuse0);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightSpecular0);
  glLightfv(GL_LIGHT0, GL_POSITION, lightPos);
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
}
void keyboard(unsigned char key, int x, int y)
{
  switch((unsigned char)key)
  {
  case 27://Esc
	  exit(0);
	  break;
  case 'R'://resetilɖ߂)
		for(int i = 0; i < 3; i++) lightPos[i] = lightPos0[i];
	  view = view0;
	  setCamera();
	  break;
  case 'l':
	  sKey = LIGHT;
	  break;
  case 'h':
	  if(flagHelp) flagHelp = false;
	  else flagHelp = true;
	  break;
  default:
	  break;
  }
}

void special(int key, int x, int y)
{
  if(sKey == LIGHT)
  {
		float d = 1.0;
	  switch( key )
	  {
	  case GLUT_KEY_RIGHT://x
		  lightPos[0] += d;
		  break;
	  case GLUT_KEY_LEFT:
		  lightPos[0] -= d;//-x
		  break;
	  case GLUT_KEY_UP:
		  if(glutGetModifiers() == 0) lightPos[1] += d;//y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] -= d;//z
		  break;
	  case GLUT_KEY_DOWN:
		  if(glutGetModifiers() == 0) lightPos[1] -= d;//-y
		  if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) lightPos[2] += d;//-z
		  break;
	  default:
		  break;
	  }
  }
	if(key == GLUT_KEY_F1)
	{
		if(glutGetModifiers() == 0) fov += 1.0;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) fov -= 1.0;
		if(fov < 5.0) fov = 5.0;
		printf("fov = %f \n", fov);
	}
	if(key == GLUT_KEY_F2)
	{
		if(glutGetModifiers() == 0) amp += 0.02;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT) amp -= 0.02;
		if(amp < 0.1) amp = 0.1;
		printf("amp = %f \n", amp);
	}
	if(key == GLUT_KEY_F3)
	{
		kindWave ++;
		if(kindWave == 3) kindWave = 0;
		printf("kindWave = %d \n", kindWave);
	}
	if(key == GLUT_KEY_F4)
	{
		numWave ++;
		if(numWave >= 4) numWave = 1;
		printf("numWave = %d \n", numWave);
	}
	if(key == GLUT_KEY_F5) 
	{
	  if(glutGetModifiers() == 0) transparency0 += 0.1;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	transparency0 -= 0.1;  
		if(transparency0 < 0.0) transparency0 = 0.0;
		if(transparency0 > 1.0) transparency0 = 1.0;
		printf("x= %f \n", transparency0);
	}	
	if(key == GLUT_KEY_F6) 
	{
		if(glutGetModifiers() == 0) nRatio0 += 0.02;
		if(glutGetModifiers() == GLUT_ACTIVE_SHIFT)	nRatio0 -= 0.02;
		printf("ܗ= %f \n", nRatio0);		
	}	
}

//ȉ̂R̊֐̓}EXɂ鎋_̕ύXɕKv
void mouse(int button, int state, int x, int y)
{
  double pp = M_PI / 180.0;

  if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
  {
	  xStart = x; yStart = y;
	  flagMouse = true;
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist -= 0.5; //߂Â
	  }
  }
  else if(button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN)
  {
	  if(x > width/4 && x < 3*width/4 && y > height/4 && y < 3*height/4)//dolly
	  {
		  view.dist += 0.5; //
	  }
	  else if(( x < width/4 || x > 3*width/4) && (y > height/4 && y < 3*height/4))//pan
	  {
		  if(x < width/4 ) view.phi -= 1.0;
		  else view.phi += 1.0;
		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.phi) * cos(pp * view.theta);
		  view.cnt[0] = view.pos[0] - view.dist * sin(pp * view.phi) * cos(pp * view.theta);
	  }
	  else if((x > width/4 && x < 3*width/4) && (y < height/4 || y > 3*height/4))//tilt
	  {
		  if( y < height/4)
			  view.theta += 1.0; 
		  else
			  view.theta -= 1.0;

		  view.cnt[2] = view.pos[2] - view.dist * cos(pp * view.theta) * cos(pp * view.phi);
		  view.cnt[0] = view.pos[0] - view.dist * cos(pp * view.theta) * sin(pp * view.phi);
		  view.cnt[1] = view.pos[1] - view.dist * sin(pp * view.theta);
	  }
	  else if(x < width/8 && y > 7*height/8) view.fovY -= 1.0;//zoom in
	  else if(x > 7*width/8 && y > 7*height/8) view.fovY += 1.0;//zoom out
  }
  else flagMouse = false;
  if(state == GLUT_DOWN) setCamera();
}

void motion(int x, int y)
{
  if(!flagMouse) return;
  if(cos(M_PI * view.theta /180.0) >= 0.0)
	view.phi -= 0.5 * (float)(x - xStart) ;//tumble
  else
	view.phi += 0.5 * (float)(x - xStart) ;//tumble

  view.theta += 0.5 * (float)(y - yStart) ;//crane

  setCamera();
  xStart = x;
  yStart = y;
}

void setCamera()
{
  double pp = M_PI / 180.0;
  view.pos[2] = view.cnt[2] + view.dist * cos(pp * view.theta) * cos(pp * view.phi);//z
  view.pos[0] = view.cnt[0] + view.dist * cos(pp * view.theta) * sin(pp * view.phi);//x
  view.pos[1] = view.cnt[1] + view.dist * sin(pp * view.theta);//y
  printf("view.posX=%f, view.posY=%f, view.posZ=%f \n", view.pos[0], view.pos[1], view.pos[2]);
  printf("cntX=%f, cntY=%f, cntZ=%f \n", view.cnt[0], view.cnt[1], view.cnt[2]);
  printf("phi=%f, theta=%f, fovY=%f \n", view.phi, view.theta, view.fovY);
	resize(width, height);
}

//2͉e`ɕKv
//------------------------------------------------------------------------
void CalcShadowMat(int objNo, float* mat)
{
  float ex, ey, ez;//̕
  float a, b, c, d;//̖ʂ̃p[^
  float s; //objectS܂ł̋
  float x, y, z;

	if(objNo == 1)
	{
		x = lightPos[0] - fish1.pos[0];
		y = lightPos[1] - fish1.pos[1];
		z = lightPos[2] - fish1.pos[2];
	}
	else
	{
		x = lightPos[0] - fish2.pos[0];
		y = lightPos[1] - fish2.pos[1];
		z = lightPos[2] - fish2.pos[2];
	}

  //̕xNg
  s = sqrt(x * x + y * y + z * z);
  ex = x / s;
  ey = y / s;
  ez = z / s;

  //tA̕xNg(j
  a = 0.0;
  b = 1.0;
  c = 0.0;
  d = -0.001; //tAƉe̊h
	//shadow matrix
  mat[0] = b * ey + c * ez;
  mat[1] = -a * ey;
  mat[2] = -a * ez;
  mat[3] = 0.0;
  mat[4] = -b * ex;
  mat[5] = a * ex + c * ez;
  mat[6] = -b * ez;
  mat[7] = 0.0;
  mat[8] = -c * ex;
  mat[9] = -c * ey;
  mat[10] = a * ex + b * ey;
  mat[11] = 0.0;
  mat[12] = -d * ex;
  mat[13] = -d * ey;
  mat[14] = -d * ez;
  mat[15] = a * ex + b * ey + c * ez;
}

//-----------------------------------------------------------------------------
void drawShadow()
{
  //vZ͕sɑ΂e
  //޼ުĂƂɌ̕ςA^Iɓ_ɑ΂e
  float mat[16]; //es̗vf

  flagShadow = true;
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

	  glDepthMask(GL_FALSE);
  //e̕`
  CalcShadowMat(1, mat);
  glPushMatrix();
	  glMultMatrixf(mat);//}gNX̏Z
	  fish1.draw();//޼ުĂ̕`
  glPopMatrix();
  CalcShadowMat(2, mat);
  glPushMatrix();
	  glMultMatrixf(mat);//}gNX̏Z
	  fish2.draw();//޼ުĂ̕`
  glPopMatrix();

  //e̕`I
  glDepthMask(GL_TRUE);
  glDisable(GL_BLEND);
  flagShadow = false;
}
