//myPet.h
//l̉z
//root͓̂̒S

#define MAXJOINT 20
#define MAXFRAME 5000//eőR}
#define MAXKEYFRAME 10//őL[t[

class CmyPet
{
public:
	CmyPet(void);
	~CmyPet(void) { };
	//oϐ
	int numJoint;//֐ߌ

	float* diffuse ;//gU˗
	float* specular;//ʌ˗
	float* ambient; //˗
	float highlight;//

	//ʒu(Root͓̂̒S)
  CVector vPos;
  //pp
  CVector vAng;
  //is
  float dir;
	//֐ߊp̔z
	CVector joint[MAXJOINT];
	//
	CVector trunk;
  //
	CVector neck;
	//
	CVector head ;
  //
  CVector eye;
	//@
	CVector nose;
  //
  CVector ear;
	//
	CVector mouth;
	//riOrCr)
	CVector leg1, leg2, foot;
  //
  CVector tail;
  //rtʒu
	CVector legPos;//̒S̑Έʒu
  //ȓŜ̒
  float legLen;
	//animationp
	CVector f_vPos[MAXFRAME];
	CVector f_vAng[MAXFRAME];
  float  f_dir[MAXFRAME];
	CVector k_vPos[MAXKEYFRAME];
	CVector k_vAng[MAXKEYFRAME];
  float  k_dir[MAXKEYFRAME];
	CVector f_joint[MAXFRAME][20];
	CVector k_joint[MAXKEYFRAME][20];
	float actTime[MAXKEYFRAME];//keyFrameԂ̓쎞
  float unitTime;//1t[̕`掞
	int numKeyFrame;//ڰѐ
	int numFrame0;//eIuWFNg1̃V[̑S\ڰѐ

	//o֐
	void draw();
	void draw(int n);
  void reset();
	void walk(float dist, float step, float tt);
  void turn(float angle, float tt);
	void stand(float tt);
	void initPose(float tt);
	void wait(float tt);
	void swingTail(int n, float tt);
	void upTail(float tt);
	void downTail(float tt);
private:
  void drawTrunk();
  void drawHead();
  void drawLeg();
  void drawLeg1(int jNo);
  void drawLeg2(int jNo);
  void drawTail();
	void initKeyAnimation();
	void makeFrameData();
  void walkRight(float step, float tt);
  void walkLeft(float step, float tt);
};
//----------------------------------------------------------------
CmyPet::CmyPet()
{

	int i;

	static float diffuse0[] = {0.9f, 0.6f, 0.4f, 1.0f};
  static float ambient0[] = {0.5f, 0.3f, 0.2f, 1.0f};
	static float specular0[] = {0.8f, 0.8f, 0.8f, 1.0f};

	//z̃}eA
	diffuse = diffuse0;
  ambient = ambient0;
  specular = specular0;
  highlight = 100.0f;

	unitTime = 0.01;//1t[̕`掞ԁi̒l)
	numJoint = 11;
  vPos = CVector();
  vAng = CVector();
	for(i = 0; i< numJoint; i++) joint[i] = CVector();

  //
	trunk = CVector( 0.2, 0.18, 0.4);
	//
	head = CVector( 0.23, 0.2, 0.23);
  //
  eye = CVector( 0.04, 0.04, 0.04);
	//@
	nose = CVector( 0.03, 0.03, 0.03);
  //
  ear = CVector( 0.03, 0.15, 0.06);
	//
	mouth = CVector(0.14, 0.14, 0.14);
	//riOrCr)
	leg1 = CVector(0.07, 0.06, 0.07);
	//riOrCr)
	leg2 = CVector(0.065, 0.06, 0.065);
  //
  tail = CVector( 0.03, 0.03, 0.20);
  //rtʒu
	legPos.x = trunk.x / 2.0 - 0.03;
  legPos.y = trunk.y / 2.0 - 0.03;//̒S̋
  legPos.z = trunk.z / 2.0 - 0.04;
  //rS
  legLen = leg1.y + leg2.y;
	//Rooẗʒuî̒S)@
	vPos.y = legLen + legPos.y;
}
//--------------------------------------------------------------------------------------
void CmyPet:: draw(int n)
{
  int j;
  //nԖڂ̃t[ԍ̎p`
  if(n > numFrame0) n = numFrame0;

  vPos = f_vPos[n];
	vAng = f_vAng[n];
	dir = f_dir[n];
  for(j = 0; j < numJoint; j++) joint[j] = f_joint[n][j];
  draw();
}


//------------------------------------------------------------------
void CmyPet::draw()
{
	glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
	glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
	glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
	glMaterialf(GL_FRONT,GL_SHININESS,highlight);

  //݈ʒu(Ŝ𓷑̂̒S܂Ŏグj
  glTranslatef(vPos.x, vPos.y, vPos.z);
  //̑Ŝ̎p
  glRotatef(vAng.y, 0.0, 1.0, 0.0); //y]
  glRotatef(vAng.x, 1.0, 0.0, 0.0); //x]
  glRotatef(vAng.z, 0.0, 0.0, 1.0); //z]
  drawTrunk();//
  drawHead();//܂߂
  drawLeg();
  drawTail();
}
//------------------------------------------------------------------------------
void CmyPet::drawTrunk(void)
{
	//
	glPushMatrix();
		glScalef(trunk.x, trunk.y, trunk.z);
    glRotatef(90.0, 1.0, 0.0, 0.0);//90xx]
		drawSuper(0.5, 16, 8, 0.5, 0.5);
	glPopMatrix();
}
//-----------------------------------------------------------------------------
void CmyPet::drawHead()
{
	static float diffuseEye[] = {0.1f, 0.1f, 0.2f, 1.0f};
  glPushMatrix();

  //̈ʒuŕsړ
	glTranslatef( 0.0, trunk.y / 2.0 - 0.02, trunk.z / 2.4 );
  //]
  glRotatef(joint[0].y, 0.0, 1.0, 0.0);//y]
  glRotatef(-90.0 + joint[0].x, 1.0, 0.0, 0.0);//x]
  glRotatef(joint[0].z, 0.0, 0.0, 1.0);//z]

  glTranslatef( 0.0, 0.0, neck.z / 2.0 + head.z / 2.0);//̐[܂ŕsړ
  //
	glPushMatrix();
		glScalef(head.x, head.y, head.z);
		drawSuper(0.5, 8, 8, 0.9, 0.8);
	glPopMatrix();
	
	//ڂ̐F
	glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, diffuseEye);
  //E
  glPushMatrix();
    glTranslatef( -head.x / 4.0, - head.y / 2.7, head.z / 3.0 );//
    glScalef(eye.x, eye.y, eye.z);
    drawSphere(0.5, 8, 8);
  glPopMatrix();
  //
  glPushMatrix();
    glTranslatef( head.x / 4.0, - head.y / 2.7, head.z / 3.0 );//
    glScalef(eye.x, eye.y, eye.z);
    drawSphere(0.5, 8, 8);
  glPopMatrix();
  //@
  glPushMatrix();
    glTranslatef( 0.0, - head.y / 1.2, head.z / 6.0 );//
    glScalef(nose.x, nose.y, nose.z);
    drawSphere(0.5, 8, 8);
  glPopMatrix();

	glMaterialfv(GL_FRONT,GL_DIFFUSE,diffuse);
	glMaterialfv(GL_FRONT,GL_AMBIENT,ambient);
  //E
  glPushMatrix();
    glTranslatef( -head.x / 2.2, 0.0, head.z / 4.0);//
    glRotatef(90.0 + joint[10].x, 1.0, 0.0, 0.0);//x]
    glScalef(ear.x, ear.y, ear.z);
    glTranslatef(0.0, -0.5, 0.0);
    drawSphere(0.5, 8, 8);
  glPopMatrix();
  //
  glPushMatrix();
    glTranslatef( head.x / 2.2, 0.0, head.z / 4.0);//
    glRotatef(90.0 + joint[10].x, 1.0, 0.0, 0.0);//x]
    glScalef(ear.x, ear.y, ear.z);
    glTranslatef(0.0, -0.5, 0.0);
    drawSphere(0.5, 8, 8);
  glPopMatrix();
	//
	glPushMatrix();
    glTranslatef( 0.0, -head.y / 2.0, 0.0);//
		glRotatef(90.0, 1.0, 0.0, 0.0);
		glScalef(mouth.x, mouth.y, mouth.z);
		drawSuper(0.5, 8, 8, 0.5, 0.7, 0.5);
	glPopMatrix();

  glPopMatrix();
}
//------------------------------------------------------------------
void CmyPet::drawLeg()
{
  //OEr
  glPushMatrix();
    // OEr̈ʒu֕sړ
    glTranslatef(-legPos.x, -legPos.y, legPos.z);
    drawLeg1(1);
    drawLeg2(5);
	glPopMatrix();
  //Or
  glPushMatrix();
    // Or̈ʒu֕sړ
    glTranslatef( legPos.x, -legPos.y, legPos.z);
    drawLeg1(2);
    drawLeg2(6);
  glPopMatrix();
  //Er
  glPushMatrix();
    // Er̈ʒu֕sړ
    glTranslatef(-legPos.x, -legPos.y, -legPos.z);
    drawLeg1(3);
    drawLeg2(7);
	glPopMatrix();
  //㍶r
  glPushMatrix();
    // ㍶r̈ʒu֕sړ
    glTranslatef( legPos.x, -legPos.y, -legPos.z);
    drawLeg1(4);
    drawLeg2(8);
	glPopMatrix();
}
//----------------------------------------------------------------------------
void CmyPet::drawLeg1(int jNo)
{
  //rt̉]
  glRotatef(joint[jNo].y, 0.0, 1.0, 0.0);//y]
  glRotatef(joint[jNo].x, 1.0, 0.0, 0.0);//x]
  glRotatef(joint[jNo].z, 0.0, 0.0, 1.0);//z]
  glPushMatrix();
    glScalef(leg1.x, leg1.y + 0.01, leg1.z );
    glTranslatef(0.0, -0.5, 0.0);//_̈ʒu։
		drawSuper(0.5, 8, 8, 0.5, 0.8);
  glPopMatrix();
}
//----------------------------------------------------------------------------
void CmyPet::drawLeg2(int jNo)
{
  //r̈ʒu֕sړ
  glTranslatef(0.0, -leg1.y, 0.0);
  //G̉]
  glRotatef(joint[jNo].y, 0.0, 1.0, 0.0);//y]
  glRotatef(joint[jNo].x, 1.0, 0.0, 0.0);//x]
  glRotatef(joint[jNo].z, 0.0, 0.0, 1.0);//z]
  glPushMatrix();
    glScalef(leg2.x, leg2.y, leg2.z);
    glTranslatef(0.0, -0.5, 0.0);//_̈ʒu։
	  drawSuper(0.5, 8, 8, 0.5, 0.8);
  glPopMatrix();
}
//----------------------------------------------------------------------------
void CmyPet::drawTail()
{
  glPushMatrix();
    //̈ʒu֕sړ
    glTranslatef( 0.0, 0.0, -trunk.z / 3.0 );
    //̉]
    glRotatef(joint[9].y, 0.0, 1.0, 0.0);//y]
    glRotatef(30.0 + joint[9].x, 1.0, 0.0, 0.0);//x]
    glRotatef(joint[9].z, 0.0, 0.0, 1.0);//z]
    glPushMatrix();
			glScalef(tail.x, tail.y, tail.z);
			glTranslatef(0.0, 0.0, -0.5);
      glRotatef(90.0, 1.0, 0.0, 0.0);//90xx]
			drawCylinder1(0.5, 0.5, 1.0, 10, 3);
    glPopMatrix();
	glPopMatrix();
}
//----------------------------------------------------------------------------
//keyframe쐬郁o֐ɂčŏcall
void CmyPet::initKeyAnimation()
{
	short k, j;
	//݂̈ʒupiŏ̎pŏ)
	for(k = 0; k < numKeyFrame; k++)
	{
		k_vPos[k] = vPos;
    k_vAng[k] = vAng;
    k_dir[k] = dir;

		for(j = 0; j < numJoint; j++) k_joint[k][j] = joint[j];
	}
}
//----------------------------------------------------------------------------
//ڰް쐬
//keyframe쐬郁o֐ōŌcall
void CmyPet::makeFrameData()
{
	short i, j, k, numHokan;
	float ss;

  if(unitTime == 0.0)
  {	printf("unitTime = 0ƂȂ܂ \n");
      return;
  }

	for(k = 1; k < numKeyFrame; k++)
  {
		if(actTime[k] < 0)
		{	printf("actTime<0ƂȂ܂ \n");
			return;//ǂ̃[`ŕ̒lɐݒ肵II
		}

		numHokan = (short)(actTime[k] / unitTime);//ԓ_
		if(numHokan == 0) continue;
		if(numFrame0 + numHokan > MAXFRAME) 
		{
			printf("t[z邨ꂪ܂ \n");
			return;
		}
		for(i = 0; i <= numHokan; i++)
		{
			ss = (float)i / (float)numHokan;
            f_vPos[numFrame0 + i] = k_vPos[k-1] + (k_vPos[k] - k_vPos[k-1]) * ss;
            f_vAng[numFrame0 + i] = k_vAng[k-1] + (k_vAng[k] - k_vAng[k-1]) * ss;
           f_dir[numFrame0 + i] = k_dir[k-1] + (k_dir[k] - k_dir[k-1]) * ss;

			for(j = 0; j < numJoint; j++)
			{//ԃf[^쐬(`)
                f_joint[numFrame0 + i][j] = k_joint[k-1][j]
				                 + (k_joint[k][j] - k_joint[k- 1][j]) * ss;
			}
		}
		numFrame0 += numHokan;
	}
	reset();
}
//---------------------------------------------------------------------------------
//cڰтްŏIlɍĐݒ
//makeFrameData()̍Ōcall
void CmyPet::reset()
{
	short i, j;

	//R}ől̍XV
	//ŏIlݒl
  if(numFrame0 > 0)
	{
    vPos = f_vPos[numFrame0];
    vAng = f_vAng[numFrame0];
    dir = f_dir[numFrame0];

		for(j = 0; j < numJoint; j++) joint[j] = f_joint[numFrame0][j];
	}

	//cׂČݒl
	for(i = numFrame0; i < MAXFRAME; i++)
	{
    f_vPos[i] = vPos;
    f_vAng[i] = vAng;
    f_dir[i] = dir;

		for(j = 0; j < numJoint; j++) f_joint[i][j] = joint[j];
	}
}
//----------------------------------------------------------------
//^ꂽ
void CmyPet::walk(float dist,  float step, float time)//
{                    //,  , ̏v,ԑ     @@@@@@
	short i, numStep, numStep2;
	float rest;

	dir = vAng.y;//݌Ă
	numStep = (short)(dist / step);
	//E,2PʂƂ
	numStep2 = numStep / 2;
	if(dist < 2.0 * step) rest = dist;
	else rest = dist - 2.0 * step * (float)numStep2;

	for(i = 0;i < numStep2; i++)
	{
		walkRight(step, time);//OEC㍶
		walkLeft(step, time); //OCE
	}
	//c(1ȓȂE)
	if(rest < step) walkRight(rest, time * rest / step);
	else	
	{	
		walkRight(step, time);
    rest -= step;
		if(rest > 0.0) walkLeft(rest, time * rest / step);
	}
}
//---------------------------------------------------------------------
void CmyPet::walkRight(float step, float time)
{
  float step2 = step / 2.0;//
  float pp = M_PI / 180.0;
  //Ҋ֐ߊpx
	float stepA = 180.0 * asin(step2 / legLen) / M_PI;
	float cc = step2 * cos(pp * dir) ;//z({płzOj
	float ss = step2 * sin(pp * dir) ;//x

	numKeyFrame = 3;
 	initKeyAnimation();
	//action1(EOrO)
	k_joint[1][1].x = -stepA;//OE
	k_joint[1][2].x = stepA; //O
	k_joint[1][3].x = stepA;//E
	k_joint[1][4].x = -stepA; //㍶
	k_vPos[1].z = k_vPos[0].z + cc;
	k_vPos[1].x = k_vPos[0].x + ss;
  k_vPos[1].y = legLen * cos(pp * k_joint[1][1].x) + legPos.y;//yW
	actTime[1] = time / 2.0;

	//action2({pɖ߂)
	k_joint[2][1].x = 0.0;//OE
	k_joint[2][2].x = 0.0; //O
	k_joint[2][3].x = 0.0;//E
	k_joint[2][4].x = 0.0; //㍶
	k_vPos[2].z = k_vPos[1].z + cc;
	k_vPos[2].x = k_vPos[1].x + ss;
  k_vPos[2].y = legLen * cos(pp * k_joint[2][1].x) + legPos.y;//zW
	actTime[2] = time / 2.0;

	makeFrameData();
}
//---------------------------------------------------------------------
void CmyPet::walkLeft(float step, float time)
{
  float step2 = step / 2.0;
  float pp = M_PI / 180.0;
  //Ҋ֐ߊpx
	float stepA = 180.0 * asin(step2 / legLen) / M_PI;
	float cc = step2 * cos(pp * dir);//z
	float ss = step2 * sin(pp * dir);//x

	numKeyFrame = 3;
 	initKeyAnimation();
	//action1(EOrO)
	k_joint[1][1].x = stepA;//OE
	k_joint[1][2].x = -stepA; //O
	k_joint[1][3].x = -stepA;//E
	k_joint[1][4].x = stepA; //㍶
	k_vPos[1].z = k_vPos[0].z + cc;
	k_vPos[1].x = k_vPos[0].x + ss;
  k_vPos[1].y = legLen * cos(pp * k_joint[1][1].x) + legPos.y;//zW
	actTime[1] = time / 2.0;

	//action2({pɖ߂)
	k_joint[2][1].x = 0.0;//OE
	k_joint[2][2].x = 0.0; //O
	k_joint[2][3].x = 0.0;//E
	k_joint[2][4].x = 0.0; //㍶
	k_vPos[2].z = k_vPos[1].z + cc;
	k_vPos[2].x = k_vPos[1].x + ss;
  k_vPos[2].y = legLen * cos(pp * k_joint[2][1].x) + legPos.y;//zW
	actTime[2] = time / 2.0;

	makeFrameData();
}
//--------------------------------------------------------------------------
//ʕ̉](angle>0ŏォ猩č])
void CmyPet::turn(float angle, float time)
{
	numKeyFrame = 2;
	initKeyAnimation();

	//݂̊e֐߂̊px
	k_vAng[1].y = vAng.y + angle;
	actTime[1] = time;
	makeFrameData();
	dir = vAng.y;
}

//rŗオ
void CmyPet::stand(float time)
{
	numKeyFrame = 2;
	initKeyAnimation();

	k_joint[1][3].x = 90.0;//E
	k_joint[1][4].x = 90.0; //㍶
  k_vPos[1].y = legLen + trunk.z / 2.0;//yW
	k_vAng[1].x = -90.0;
	k_joint[1][0].x = 90.0;
	actTime[1] = time ;
	makeFrameData();
}

//{pɖ߂
void CmyPet::initPose(float time)
{
	short j;
	
	numKeyFrame = 2;
	initKeyAnimation();

	for(j = 0; j < numJoint; j++) k_joint[1][j] = CVector();
	k_vAng[1].x = 0.0;
	k_vAng[1].z = 0.0;
	k_vPos[1].y = legLen + legPos.y;//rooẗʒu
	actTime[1] = time;
	makeFrameData();
}

void CmyPet::wait(float time)
{
	numKeyFrame = 2;
	initKeyAnimation();
	actTime[1] = time;
	makeFrameData();
}

void CmyPet::swingTail(int n, float time)
{
	short i;
	
	for(i = 0; i < n; i++) 
	{
		upTail(time/2.0);
		downTail(time/2.0);
	}
}

void CmyPet::upTail(float time)
{
	numKeyFrame = 2;
	initKeyAnimation();
	k_joint[1][9].x += 60.0;
	actTime[1] = time;
	makeFrameData();
}

void CmyPet::downTail(float time)
{
	numKeyFrame = 2;
	initKeyAnimation();
	k_joint[1][9].x -= 60.0;
	actTime[1] = time;
	makeFrameData();
}

 